/** 
 * Klasse som kontakter DbKobling for kobling mot database
 * @author Toril
 * @see DbKobling
 */
import java.sql.*;
import java.util.ArrayList;
public class DbId {
	private ArrayList id;
	private DbKobling kobling;
	private int tablesize;
	
	/** 
	 * Standard konstruktor
	 * 
	 * Oppretter kontakt med DbKobling
	 */
	public DbId(){
		kobling = new DbKobling();
		tablesize = kobling.getTablsize();
		id = new ArrayList();
	}
	/** 
	 * Metode som lager IdTabell av alle "id" er i databasen
	 * @exception SqlException
	 *
	 */
	public void setIdTabell(){
		Statement sqlSetning = kobling.lagSetning();
		if(sqlSetning != null){
			String sql = "SELECT id from dc WHERE language='en'";
			ResultSet res = kobling.lagSporring(sql);
			try{
				int i = 0;
				while(res.next()){
					
					String idDok = res.getString("id");
					id.add(i, idDok);
					i++;
				}
			}
			catch(Exception x){
				System.out.println("x: " +x);
			}
		}
	}
	/** Metode som henter id
	 * @return ArrayList
	 */
	public ArrayList getId(){
		return id;
	}
	/** Metode som henter str p tabell
	 * 
	 * @return int tabellstrrelse
	 */
	public int getTableSize(){
		return kobling.getTablsize();
	}
	/** Metode som henter Id
	 * 
	 * @param index int
	 * @return String id
	 */
	public String getId(int index){
		return (String)id.get(index);
	}
	/** Metode som henter innhold i gitt felt for et dokument ved  bruke id i fra id-tabell i sprringen
	 * 
	 * @param index int
	 * @param felt String
	 * @return String kolInnhold 
	 * @exception SqlException
	 */
	public String getKolInn(int index, String felt){
		String kolInnhold = new String();
		String identitet = getId(index);
		Statement sqlSetning = kobling.lagSetning();
		if(sqlSetning != null){
			String sql = "SELECT " +felt+ " from dc WHERE id='" +identitet+ "'";
			ResultSet res = kobling.lagSporring(sql);
			try{
				while(res.next()){
				kolInnhold = res.getString(felt);
				}
			}
			
			catch(Exception y){
				System.out.println("Y: " +y);
			}
		}return kolInnhold;
	}
	
}
