/**Klasse som oppretter direkte kontakt med database
 * @author Toril Ormberg Reite
 * @see DbId
 */
import java.sql.*;

public class DbKobling{
	Connection kontakt;
	/** Standard konstruktor
	 *
	 */
	public DbKobling(){
	}
	/** Metode som oppretter forbindelse til databasen.
	 *  @return kontakt Connection
	 */
	public Connection opprettForbindelse(){
		try{
			Class.forName("com.mysql.jdbc.Driver").newInstance();
			kontakt = DriverManager.getConnection("jdbc:mysql://localhost:3306/arc?user=toril&password=");
			//System.out.println("Kontakt er opprettet: " + kontakt);
			
        } 
		catch (Exception ex){
			System.out.println("Feilen er: " + ex);
		}return kontakt;
	}
	/** Metode som returnerer et Statement objekt til bruk ved kontakt av database.
	 * @return sqlSetning Statement
	 */
	public Statement lagSetning(){
		if(kontakt == null){
			opprettForbindelse();
		}
		Statement sqlS = null;
		try{
			sqlS = kontakt.createStatement();
		}catch(Exception e){
			System.out.println("SQL feil: " +e);
		}return sqlS;
		
	}
	/** Metode som fr strrelsen p tabellen over alle "id"ene i databasen.
	 * @return tablecount int
	 * @exception SqlException
	 */
	public int getTablsize(){
		int tablecount = 0;
		Statement st = lagSetning();
		if(st != null){
			String sql = "SELECT COUNT(id) FROM dc WHERE language='en'";
			ResultSet res = lagSporring(sql);
			try{
				while(res.next()){
					String count = res.getString("COUNT(id)");
					Integer teller = new Integer(count);
					tablecount = teller.intValue();
					//System.out.println(tablecount);
				}
			
			}
			catch(Exception e){
			System.out.println("e: " +e);
			}
		}return tablecount;
	}
	/** Metode som returner et ResultSet objekt, ved  ta inn en streng som er en SQL-sprring.
	 * @return res ResultSet
	 */
	public ResultSet lagSporring(String sqlSetning){
		Statement sqlS = lagSetning();
		ResultSet res = null;
		try{
			res = sqlS.executeQuery(sqlSetning);
		}
		catch(Exception f){
			System.out.println("F: " +f);
		}return res;
	}
	/** Lukker forbindelsen til databasen
	 * 
	 */
	public void lukkForbindelse(){
		try{
			kontakt.close();
		}
		catch(Exception e){
			System.out.println("Feil i lukking av forbindelsen: " +e);
		}
	}
	
}


