/** Klasse Document
 * @author Toril
 * @version mai 06 
 */
import java.util.*;
public class Document {
	private String title;
	private String description;
	private String subject;;
	private VektorModell vektorModell;
	private ArrayList subjectThisDocument;
	private double[] normVector;
	
	/** Konstruktr
	 * Konstruktr som tar inn en tittel streng og en description streng. Oppretter en ArrayList() for 
	 *  holde orden p hvilke Subject (tema) dette dokumentet har i fra databasen.
	 */
	public Document(String title, String description){
		this.title = title;
		this.description = description;;
		subjectThisDocument = new ArrayList();
	}
	/** Metode som henter inn termene i fra tittel og description og returnerer disse som en ArrayList 
	 * med termer for dokumentet.
	 * @return termer ArrayList
	 */
	public ArrayList getTerms(){
		ArrayList termer = new ArrayList();
		StringTokenizer st = new StringTokenizer(fjernTegnTitle().toLowerCase());
		while(st.hasMoreTokens()){
			termer.add(st.nextToken().trim());
		}
		st = new StringTokenizer(fjernTegnDescription().toLowerCase());
		while(st.hasMoreTokens()){
			termer.add(st.nextToken().trim());
		}
		return termer;
	}
	/**Hjelpemetode som fjerner tegn i fra title, tegn som gjr at et ord kan vises to 
	 * ganger selv om det er det samme ordet
	 * @return title String
	 */
	public String fjernTegnTitle(){
		for(int i = 0; i<title.length(); i++){
			char a = title.charAt(i);
			//System.out.println("a: " +a);
			if(a == ',' || a == '.' || a== '\"'|| a== '(' || a==')' || a == '!' || a == '?' || a ==':' || a== ';' || a=='[' ||a==']'){
					char b = ' ';
					title = title.replace(a, b);
					//System.out.println(s);
			}
		}return title;
	}
	/** Hjelpemetode som fjerner tegn i fra description p samme mte som for title og av samme grunn.
	 * @return description String
	 */
	public String fjernTegnDescription(){
		for(int i = 0; i<description.length(); i++){
			char a = description.charAt(i);
			//System.out.println("a: " +a);
			if(a == ',' || a == '.' || a== '\"'|| a== '(' || a==')' || a == '!' || a == '?' || a ==':' || a== ';' || a=='[' ||a==']'){
					char b = ' ';
					description = description.replace(a, b);
					//System.out.println(s);
			}
		}return description;
	}
	/** Hjelpemetode som fjerner tegn i fra Subject p samme mte som for title og av samme grunn.
	 * @return subject String
	 */
	public String fjernTegnSubject(){
		for(int i = 0; i<subject.length(); i++){
			char a = subject.charAt(i);
			//System.out.println("a: " +a);
			if(a == ',' || a == '.' || a== '\"'|| a== '(' || a==')' || a == '!' || a == '?' || a ==':' || a== ';' || a=='[' ||a==']'){
					char b = ' ';
					subject = subject.replace(a, b);
					//System.out.println(s);
			}
		}return subject;
	}
	/** Metode som returnerer title som en streng.
	 * @return title String
	 * 
	 */
	public String getTitle(){
		return title;
	}
	/** Metode som returnerer description som en streng.
	 * @return description String
	 */
	public String getDescription(){
		return description;
	}
	/** Metode som returnerer Subject som en streng.
	 * @return subject String
	 * 
	 */
	public String getSubject(){
		return subject;
	}
	/** Hjelpe metode som returner et objekt av VektorModell, m sende inn et objekt av Samling.
	 *
	 * @param collection Samling
	 * @return vektorModell VektorModell
	 */
	public VektorModell getVektorModell(Samling collection){
		vektorModell = new VektorModell(this, collection);
		return vektorModell;
	}
	/** Metode som setter normalisert vektor for dokumentet.
	 * @param collection samling
	 * 
	 */
	public void setNormVector(Samling collection){
		normVector = getVektorModell(collection).lagNormalizedVector(getVektorModell(collection));
	}
	/** Metode som returnerer en normalisert vektor i form av en double[] tabell.
	 * @return normVector double[]
	 * 
	 */
	public double[] getNormVector(){
		return normVector;
	}
	/** Metode som legger til et subject i listen over subject for dette dokumentet. Reelle subjekt!
	 * @param subject Subject
	 */
	public void addSubject(Subject subject){
		if(!subjectThisDocument.contains(subject)){
			subjectThisDocument.add(subject);
		}
	}
	/** Metode som henter ut Subjectene fra dette dokumentet.
	 * @return subjectThisDocument ArrayList
	 */
	public ArrayList getSubjectThisDocument(){
		return subjectThisDocument;
	}

}
