/** PredictSubject er main klassen
 * @author Toril
 * @version mai 06
 */
import java.util.*;
import java.io.*;
import java.lang.*;
public class PredictSubject{
	private Samling collection;
	private int deleTall;
	
	/** Konstruktr, oppretter PredictSubject objekt 
	 * 
	 * @param collection Samling
	 * @param deleTall int (antallet klassen skal deles p)
	 */
	public PredictSubject(Samling collection, int deleTall){
		this.collection = collection;
		this.deleTall = deleTall;
	}
	/** Metode som teller antall treff ved sammenligning med frste subject i listen over gjettede subject
	 * 
	 * @param start int startindex for denne del av testsett
	 * @param stop int sluttindex for denne del av testsett
	 * @param relevant RelevantSubjects, angir treningssett
	 * @return countAntallTreff A int
	 */
	public int countAntallTreffA(int start, int stop, RelevantSubjects relevant){
		ArrayList documentSubject = new ArrayList();
		ArrayList predictetSubject = new ArrayList();
		int counter = 0;
		Document doc;
		for(int i=start; i<stop; i++){
			doc = (Document)collection.getCollection().get(i);
			VektorModell docModell = new VektorModell(doc, collection);
			predictetSubject = relevant.returnProbbleSubject(docModell);
			documentSubject = doc.getSubjectThisDocument();
			boolean a = documentSubject.contains(predictetSubject.get(0));
			if(a){
				counter = counter + 1;
				
			}
		}
		return counter;
	}
	/** 
	 * Metode som teller antall treff ved sammenligning med frste eller andre subject i listen over 
	 * gjettede subject
	 * 
	 * @param start int startindex for denne del av testsett
	 * @param stop int sluttindex for denne del av testsett
	 * @param relevant RelevantSubjects, angir treningssett
	 * @return countAntallTreff A eller B int
	 */
	public int countAntallTreffAB(int start, int stop, RelevantSubjects relevant){
		ArrayList documentSubject = new ArrayList();
		ArrayList predictetSubject = new ArrayList();
		int counter = 0;
		for(int i=start; i<stop; i++){
			Document doc = (Document)collection.getCollection().get(i);
			VektorModell docModell = new VektorModell(doc, collection);
			predictetSubject = relevant.returnProbbleSubject(docModell);
			documentSubject = doc.getSubjectThisDocument();
			boolean a = documentSubject.contains(predictetSubject.get(0));
			boolean b = documentSubject.contains(predictetSubject.get(1));
			if(a | b){
				counter = counter + 1;
				
			}
		}
		return counter;
	}
	/** 
	 * Metode som teller antall treff ved sammenligning med frste eller andre 
	 * eller tredje subject i listen over gjettede subject
	 * 
	 * @param start int startindex for denne del av testsett
	 * @param stop int sluttindex for denne del av testsett
	 * @param relevant RelevantSubjects, angir treningssett
	 * @return countAntallTreff A eller B eller C int
	 */
	public int countAntallTreffABC(int start, int stop, RelevantSubjects relevant){
		ArrayList documentSubject = new ArrayList();
		ArrayList predictetSubject = new ArrayList();
		int counter = 0;
		for(int i=start; i<stop; i++){
			Document doc = (Document)collection.getCollection().get(i);
			VektorModell docModell = new VektorModell(doc, collection);
			predictetSubject = relevant.returnProbbleSubject(docModell);
			documentSubject = doc.getSubjectThisDocument();
			boolean a = documentSubject.contains(predictetSubject.get(0));
			boolean b = documentSubject.contains(predictetSubject.get(1));
			boolean c = documentSubject.contains(predictetSubject.get(2));
			if(a | b | c){
				counter = counter + 1;
				
			}
		}
		return counter;
	}
	/** 
	 * Metode som teller antall treff ved sammenligning med frste, andre, tredje eller fjerde subject i 
	 * listen over gjettede subject
	 * 
	 * @param start int startindex for denne del av testsett
	 * @param stop int sluttindex for denne del av testsett
	 * @param relevant RelevantSubjects, angir treningssett
	 * @return countAntallTreff A eller B eller C eller D int
	 */
	public int countAntallTreffABCD(int start, int stop, RelevantSubjects relevant){
		ArrayList documentSubject = new ArrayList();
		ArrayList predictetSubject = new ArrayList();
		int counter = 0;
		for(int i=start; i<stop; i++){
			Document doc = (Document)collection.getCollection().get(i);
			VektorModell docModell = new VektorModell(doc, collection);
			predictetSubject = relevant.returnProbbleSubject(docModell);
			documentSubject = doc.getSubjectThisDocument();
			boolean a = documentSubject.contains(predictetSubject.get(0));
			boolean b = documentSubject.contains(predictetSubject.get(1));
			boolean c = documentSubject.contains(predictetSubject.get(2));
			boolean d = documentSubject.contains(predictetSubject.get(3));
			if(a| b | c | d){
				counter = counter + 1;
				
			}
		}
		return counter;
	}
	/** 
	 * Metode som teller antall treff ved sammenligning med frste, andre, tredje, fjerde  eller femte 
	 * subject i listen over gjettede subject
	 * 
	 * @param start int startindex for denne del av testsett
	 * @param stop int sluttindex for denne del av testsett
	 * @param relevant RelevantSubjects, angir treningssett
	 * @return countAntallTreff A eller B eller C eller D eller E int
	 */
	public int countAntallTreffABCDE(int start, int stop, RelevantSubjects relevant){
		ArrayList documentSubject = new ArrayList();
		ArrayList predictetSubject = new ArrayList();
		int counter = 0;
		for(int i=start; i<stop; i++){
			Document doc = (Document)collection.getCollection().get(i);
			VektorModell docModell = new VektorModell(doc, collection);
			predictetSubject = relevant.returnProbbleSubject(docModell);
			documentSubject = doc.getSubjectThisDocument();
			boolean a = documentSubject.contains(predictetSubject.get(0));
			boolean b = documentSubject.contains(predictetSubject.get(1));
			boolean c = documentSubject.contains(predictetSubject.get(2));
			boolean d = documentSubject.contains(predictetSubject.get(3));
			boolean e = documentSubject.contains(predictetSubject.get(4));
			if(a | b |c |d |e){
				counter = counter + 1;
				
			}
		}
		return counter;
	}
	/** Metode som skriver resultater i fra sammenligningene til fil
	 * Metoden er veldig statisk.
	 * @exception IOException
	 *
	 */
	public void skrivResultaterTilFil(){
		try{
		String fileName = "testings.txt";
		VektorModell modell = new VektorModell((Document)collection.getCollection().get(0), collection);
		PrintWriter skriv = new PrintWriter(new BufferedWriter(new FileWriter(fileName)));
		int stop = collection.getCollection().size()/deleTall;
		System.out.println("Skriveklasse Startet......");
		/////////////////////////////Del 1, Relevant Del 1, Mot seg selv ////////////////////
		RelevantSubjects relevant1 = collection.getNextDocument(0, stop);
		relevant1.setMeanVectors(modell);
		System.out.println("Relevant Subject 1: " +relevant1.toString());
		System.out.println("Antall relevante subject: " +relevant1.getSubjectSet().size());
		int startDel1 = 0; 
		int stopDel1 = collection.getCollection().size()/deleTall;
		int res1Del1a = countAntallTreffA(startDel1, stopDel1, relevant1);
		System.out.println("res1Del1a: " +res1Del1a);
		int res1Del1ab = countAntallTreffAB(startDel1, stopDel1, relevant1);
		System.out.println("res1Del1ab: " +res1Del1ab);
		int res1Del1abc = countAntallTreffABC(startDel1, stopDel1, relevant1);
		System.out.println("res1Del1abc: " +res1Del1abc);
		int res1Del1abcd = countAntallTreffABCD(startDel1, stopDel1, relevant1); 
		System.out.println("res1Del1abcd: " +res1Del1abcd);
		int res1Del1abcde = countAntallTreffABCDE(startDel1, stopDel1, relevant1); 
		System.out.println("res1Del1abcde: " +res1Del1abcde);
		System.out.println("Starter  skrive.....");
		skriv.println("*  a  *  b  *  c  *  d  *  e  *** Relevant del 1");
		skriv.println("*  " +res1Del1a+ "  *  " +res1Del1ab+"  *  " +res1Del1abc+ "  *  " +res1Del1abcd+ "  *  " +res1Del1abcde+"  *** 1");
		/* **************************Del 2************************* */
		int startDel2 = collection.getCollection().size()/deleTall ; 
		int stopDel2 = (collection.getCollection().size()/deleTall)*2;
		int res1Del2a = countAntallTreffA(startDel2, stopDel2, relevant1);
		System.out.println("res1Del2a: " +res1Del2a);
		int res1Del2ab = countAntallTreffAB(startDel2, stopDel2, relevant1);
		System.out.println("res1Del2ab: " +res1Del2ab);
		int res1Del2abc = countAntallTreffABC(startDel2, stopDel2, relevant1); 
		System.out.println("res1Del2abc: " +res1Del2abc);
		int res1Del2abcd = countAntallTreffABCD(startDel2, stopDel2, relevant1); 
		System.out.println("res1Del2abcd: " +res1Del2abcd);
		int res1Del2abcde = countAntallTreffABCDE(startDel2, stopDel2, relevant1);
		System.out.println("res1Del2abcde: " +res1Del2abcde);
		skriv.println("*  "  +res1Del2a+  " * "  +res1Del2ab+" * " +res1Del2abc+ " * " +res1Del2abcd+ " * " +res1Del2abcde+" *** 2");
		/* *********************Del 3 **************************** */
		int startDel3 = (collection.getCollection().size()/deleTall)*2 ; 
		int stopDel3 = (collection.getCollection().size()/deleTall)*3;
		int res1Del3a = countAntallTreffA(startDel3, stopDel3, relevant1);
		System.out.println("res1Del3a: " +res1Del3a);
		int res1Del3ab = countAntallTreffAB(startDel3, stopDel3, relevant1);
		System.out.println("res1Del3ab: " +res1Del3ab);
		int res1Del3abc = countAntallTreffABC(startDel3, stopDel3, relevant1); 
		System.out.println("res1Del3abc: " +res1Del3abc);
		int res1Del3abcd = countAntallTreffABCD(startDel3, stopDel3, relevant1); 
		System.out.println("res1Del3abcd: " +res1Del3abcd);
		int res1Del3abcde = countAntallTreffABCDE(startDel3, stopDel3, relevant1); 
		System.out.println("res1Del3abcde: " +res1Del3abcde);
		skriv.println("*  " +res1Del3a+ " * " +res1Del3ab+" * " +res1Del3abc+ " * " +res1Del3abcd+ " * " +res1Del3abcde+" *** 3");
		/* ********************** Del 4 *************************** */
		int startDel4 = (collection.getCollection().size()/deleTall)*3 ; 
		int stopDel4 = (collection.getCollection().size()/deleTall)*4;
		int res1Del4a = countAntallTreffA(startDel4, stopDel4, relevant1);
		System.out.println("res1Del4a: " +res1Del4a);
		int res1Del4ab = countAntallTreffAB(startDel4, stopDel4, relevant1); 
		System.out.println("res1Del4ab: " +res1Del4ab);
		int res1Del4abc = countAntallTreffABC(startDel4, stopDel4, relevant1); 
		System.out.println("res1Del4abc: " +res1Del4abc);
		int res1Del4abcd = countAntallTreffABCD(startDel4, stopDel4, relevant1); 
		System.out.println("res1Del4abcd: " +res1Del4abcd);
		int res1Del4abcde = countAntallTreffABCDE(startDel4, stopDel4, relevant1); 
		System.out.println("res1Del4abcde: " +res1Del4abcde);
		skriv.println("*  " +res1Del4a+ " * " +res1Del4ab+" * " +res1Del4abc+ " * " +res1Del4abcd+ " * " +res1Del4abcde+" *** 4");
		skriv.println("");
		relevant1.emptyDocTablesInSubjects();
		//////////////////////////Del 1, Relevant del 2 /////////////////////////////
		RelevantSubjects relevant2 = collection.getNextDocument(startDel2, stopDel2);
		relevant2.setMeanVectors(modell);
		int res2Del1a = countAntallTreffA(startDel1, stopDel1, relevant2);
		System.out.println("res2Del1a: " +res2Del1a);
		int res2Del1ab = countAntallTreffAB(startDel1, stopDel1, relevant2); 
		System.out.println("res2Del1ab: " +res2Del1ab);
		int res2Del1abc = countAntallTreffABC(startDel1, stopDel1, relevant2); 
		System.out.println("res2Del1abc: " +res2Del1abc);
		int res2Del1abcd = countAntallTreffABCD(startDel1, stopDel1, relevant2); 
		System.out.println("res2Del1abcd: " +res2Del1abcd);
		int res2Del1abcde = countAntallTreffABCDE(startDel1, stopDel1, relevant2); 
		System.out.println("res2Del1abcde: " +res2Del1abcde);
		skriv.println("*  a  *  b  *  c  *  d  *  e  *** Relevant del 2");
		skriv.println("* " +res2Del1a+ " * " +res2Del1ab+" * " +res2Del1abc+ " * " +res2Del1abcd+ " * " +res2Del1abcde+" *** 1");
		/////////////////////////Del 2 Mot seg selv////////////////////////////////
		int res2Del2a = countAntallTreffA(startDel2, stopDel2, relevant2);
		System.out.println("res2Del2a: " +res2Del2a);
		int res2Del2ab = countAntallTreffAB(startDel2, stopDel2, relevant2); 
		System.out.println("res2Del2ab: " +res2Del2ab);
		int res2Del2abc = countAntallTreffABC(startDel2, stopDel2, relevant2); 
		System.out.println("res2Del2abc: " +res2Del2abc);
		int res2Del2abcd = countAntallTreffABCD(startDel2, stopDel2, relevant2); 
		System.out.println("res2Del2abcd: " +res2Del2abcd);
		int res2Del2abcde = countAntallTreffABCDE(startDel2, stopDel2, relevant2); 
		System.out.println("res2Del2abcde: " +res2Del2abcde);
		skriv.println("* " +res2Del2a+ " * " +res2Del2ab+" * " +res2Del2abc+ " * " +res2Del2abcd+ " * " +res2Del2abcde+" *** 2");
		/////////////////////////Del 3 ///////////////////////////////////////////////
		int res2Del3a = countAntallTreffA(startDel3, stopDel3, relevant2);
		System.out.println("res2Del3a: " +res2Del3a);
		int res2Del3ab = countAntallTreffAB(startDel3, stopDel3, relevant2); 
		System.out.println("res2Del3ab: " +res2Del3ab);
		int res2Del3abc = countAntallTreffABC(startDel3, stopDel3, relevant2); 
		System.out.println("res2Del3abc: " +res2Del3abc);
		int res2Del3abcd = countAntallTreffABCD(startDel3, stopDel3, relevant2); 
		System.out.println("res2Del3abcd: " +res2Del3abcd);
		int res2Del3abcde = countAntallTreffABCDE(startDel3, stopDel3, relevant2); 
		System.out.println("res2Del3abcde: " +res2Del3abcde);
		skriv.println("* " +res2Del3a+ " * " +res2Del3ab+" * " +res2Del3abc+ " * " +res2Del3abcd+ " * " +res2Del3abcde+" *** 3");
		/////////////////////////Del 4////////////////////////////////////////////////
		int res2Del4a = countAntallTreffA(startDel4, stopDel4, relevant2);
		System.out.println("res2Del4a: " +res2Del4a);
		int res2Del4ab = countAntallTreffAB(startDel4, stopDel4, relevant2); 
		System.out.println("res2Del4ab: " +res2Del4ab);
		int res2Del4abc = countAntallTreffABC(startDel4, stopDel4, relevant2); 
		System.out.println("res2Del4abc: " +res2Del4abc);
		int res2Del4abcd = countAntallTreffABCD(startDel4, stopDel4, relevant2); 
		System.out.println("res2Del4abcd: " +res2Del4abcd);
		int res2Del4abcde = countAntallTreffABCDE(startDel4, stopDel4, relevant2); 
		System.out.println("res2Del4abcde: " +res2Del4abcde);
		skriv.println("* " +res2Del4a+ " * " +res2Del4ab+" * " +res2Del4abc+ " * " +res2Del4abcd+ " * " +res2Del4abcde+" *** 4");
		relevant2.emptyDocTablesInSubjects();
		/////////////////////////Del 1, Relevant Del 3 //////////////////////////////////
		RelevantSubjects relevant3 = collection.getNextDocument(startDel3, stopDel3);
		relevant3.setMeanVectors(modell);
		int res3Del1a = countAntallTreffA(startDel1, stopDel1, relevant3);
		System.out.println("res3Del1a: " +res3Del1a);
		int res3Del1ab = countAntallTreffAB(startDel1, stopDel1, relevant3); 
		System.out.println("res3Del1ab: " +res3Del1ab);
		int res3Del1abc = countAntallTreffABC(startDel1, stopDel1, relevant3); 
		System.out.println("res3Del1abc: " +res3Del1abc);
		int res3Del1abcd = countAntallTreffABCD(startDel1, stopDel1, relevant3); 
		System.out.println("res3Del1abcd: " +res3Del1abcd);
		int res3Del1abcde = countAntallTreffABCDE(startDel1, stopDel1, relevant3); 
		System.out.println("res3Del1abcde: " +res3Del1abcde);
		skriv.println("");
		skriv.println("*  a  *  b  *  c  *  d  *  e  *** Relevant del 3");
		skriv.println("* " +res3Del1a+ " * " +res3Del1ab+" * " +res3Del1abc+ " * " +res3Del1abcd+ " * " +res3Del1abcde+" *** 1");
		/////////////////////////Del 2 /////////////////////////////////////////////////
		int res3Del2a = countAntallTreffA(startDel2, stopDel2, relevant3);
		System.out.println("res3Del2a: " +res3Del2a);
		int res3Del2ab = countAntallTreffAB(startDel2, stopDel2, relevant3); 
		System.out.println("res3Del2ab: " +res3Del2ab);
		int res3Del2abc = countAntallTreffABC(startDel2, stopDel2, relevant3); 
		System.out.println("res3Del2abc: " +res3Del2abc);
		int res3Del2abcd = countAntallTreffABCD(startDel2, stopDel2, relevant3); 
		System.out.println("res3Del2abcd: " +res3Del2abcd);
		int res3Del2abcde = countAntallTreffABCDE(startDel2, stopDel2, relevant3);
		System.out.println("res3Del2abcde: " +res3Del2abcde);
		skriv.println("* " +res3Del2a+ " * " +res3Del2ab+" * " +res3Del2abc+ " * " +res3Del2abcd+ " * " +res3Del2abcde+" *** 2");
		/////////////////////////Del 3 Mot seg selv////////////////////////////////////
		int res3Del3a = countAntallTreffA(startDel3, stopDel3, relevant3);
		System.out.println("res3Del3a: " +res3Del3a);
		int res3Del3ab = countAntallTreffAB(startDel3, stopDel3, relevant3); 
		System.out.println("res3Del3ab: " +res3Del3ab);
		int res3Del3abc = countAntallTreffABC(startDel3, stopDel3, relevant3); 
		System.out.println("res3Del3abc: " +res3Del3abc);
		int res3Del3abcd = countAntallTreffABCD(startDel3, stopDel3, relevant3); 
		System.out.println("res3Del3abcd: " +res3Del3abcd);
		int res3Del3abcde = countAntallTreffABCDE(startDel3, stopDel3, relevant3);
		System.out.println("res3Del3abcde: " +res3Del3abcde);
		skriv.println("* " +res3Del3a+ " * " +res3Del3ab+" * " +res3Del3abc+ " * " +res3Del3abcd+ " * " +res3Del3abcde+" *** 3");
		/////////////////////////Del 4 ////////////////////////////////////////////////
		int res3Del4a = countAntallTreffA(startDel4, stopDel4, relevant3);
		System.out.println("res3Del4a: " +res3Del4a);
		int res3Del4ab = countAntallTreffAB(startDel4, stopDel4, relevant3); 
		System.out.println("res3Del4ab: " +res3Del4ab);
		int res3Del4abc = countAntallTreffABC(startDel4, stopDel4, relevant3); 
		System.out.println("res3Del4abc: " +res3Del4abc);
		int res3Del4abcd = countAntallTreffABCD(startDel4, stopDel4, relevant3); 
		System.out.println("res3Del4abcd: " +res3Del4abcd);
		int res3Del4abcde = countAntallTreffABCDE(startDel4, stopDel4, relevant3);
		System.out.println("res3Del4abcde: " +res3Del4abcde);
		skriv.println("* " +res3Del4a+ " * " +res3Del4ab+" * " +res3Del4abc+ " * " +res3Del4abcd+ " * " +res3Del4abcde+" *** 4");
		relevant3.emptyDocTablesInSubjects();
		/////////////////////////Del 1, Relevant Del 4 /////////////////////////////////
		RelevantSubjects relevant4 = collection.getNextDocument(startDel4, stopDel4);
		relevant4.setMeanVectors(modell);
		int res4Del1a = countAntallTreffA(startDel1, stopDel1, relevant4);
		System.out.println("res4Del1a: " +res4Del1a);
		int res4Del1ab = countAntallTreffAB(startDel1, stopDel1, relevant4); 
		System.out.println("res4Del1ab: " +res4Del1ab);
		int res4Del1abc = countAntallTreffABC(startDel1, stopDel1, relevant4); 
		System.out.println("res4Del1abc: " +res4Del1abc);
		int res4Del1abcd = countAntallTreffABCD(startDel1, stopDel1, relevant4); 
		System.out.println("res4Del1abcd: " +res4Del1abcd);
		int res4Del1abcde = countAntallTreffABCDE(startDel1, stopDel1, relevant4);
		System.out.println("res4Del1abcde: " +res4Del1abcde);
		skriv.println("");
		skriv.println("*  a  *  b  *  c  *  d  *  e  *** Relevant del 4");
		skriv.println("* " +res4Del1a+ " * " +res4Del1ab+" * " +res4Del1abc+ " * " +res4Del1abcd+ " * " +res4Del1abcde+" *** 1");
		/////////////////////////Del 2 ////////////////////////////////////////////////
		int res4Del2a = countAntallTreffA(startDel2, stopDel2, relevant4);
		System.out.println("res4Del2a: " +res4Del2a);
		int res4Del2ab = countAntallTreffAB(startDel2, stopDel2, relevant4); 
		System.out.println("res4Del2ab: " +res4Del2ab);
		int res4Del2abc = countAntallTreffABC(startDel2, stopDel2, relevant4); 
		System.out.println("res4Del2abc: " +res4Del2abc);
		int res4Del2abcd = countAntallTreffABCD(startDel2, stopDel2, relevant4); 
		System.out.println("res4Del2abcd: " +res4Del2abcd);
		int res4Del2abcde = countAntallTreffABCDE(startDel2, stopDel2, relevant4);
		System.out.println("res4Del2abcde: " +res4Del2abcde);
		skriv.println("* " +res4Del2a+ " * " +res4Del2ab+" * " +res4Del2abc+ " * " +res4Del2abcd+ " * " +res4Del2abcde+" *** 2");
		/////////////////////////Del 3 /////////////////////////////////////////////////
		int res4Del3a = countAntallTreffA(startDel3, stopDel3, relevant4);
		System.out.println("res4Del3a: " +res4Del3a);
		int res4Del3ab = countAntallTreffAB(startDel3, stopDel3, relevant4); 
		System.out.println("res4Del3ab: " +res4Del3ab);
		int res4Del3abc = countAntallTreffABC(startDel3, stopDel3, relevant4); 
		System.out.println("res4Del3abc: " +res4Del3abc);
		int res4Del3abcd = countAntallTreffABCD(startDel3, stopDel3, relevant4); 
		System.out.println("res4Del3abcd: " +res4Del3abcd);
		int res4Del3abcde = countAntallTreffABCDE(startDel3, stopDel3, relevant4);
		System.out.println("res4Del3abcde: " +res4Del3abcde);
		skriv.println("* " +res4Del3a+ " * " +res4Del3ab+" * " +res4Del3abc+ " * " +res4Del3abcd+ " * " +res4Del3abcde+" *** 3");
		//////////////////////////Del 4 Mot seg selv //////////////////////////////////////
		int res4Del4a = countAntallTreffA(startDel4, stopDel4, relevant4);
		System.out.println("res4Del4a: " +res4Del4a);
		int res4Del4ab = countAntallTreffAB(startDel4, stopDel4, relevant4); 
		System.out.println("res4Del4ab: " +res4Del4ab);
		int res4Del4abc = countAntallTreffABC(startDel4, stopDel4, relevant4); 
		System.out.println("res4Del4abc: " +res4Del4abc);
		int res4Del4abcd = countAntallTreffABCD(startDel4, stopDel4, relevant4); 
		System.out.println("res4Del4abcd: " +res4Del4abcd);
		int res4Del4abcde = countAntallTreffABCDE(startDel4, stopDel4, relevant4);
		System.out.println("res4Del4abcde: " +res4Del4abcde);
		skriv.println("* " +res4Del4a+ " * " +res4Del4ab+" * " +res4Del4abc+ " * " +res4Del4abcd+ " * " +res4Del4abcde+" *** 4");
		skriv.println("");
		skriv.println("Antall dokumenter i samlingen: " +collection.getAntallDoc());
		skriv.println("Antall dokumenter i hver del: " +collection.getAntallDoc()/deleTall);
		relevant4.emptyDocTablesInSubjects();
		skriv.close();
		System.out.println("Start Del 4: " +startDel4);
		System.out.println("Stop Del 4: " +stopDel4);
		System.out.println("The End");
				
		}
		catch(IOException e){
			System.out.println("e: " +e);
		}
	}
	/** Main metoden
	 * Henter inn ordliste i fra fil og lager ArrayList og HashSet av det som sendes til Vocabulary.
	 * mainmetoden, har en konstruktor som tar inn en collection og et antall samlingen skal deles i(4)
	 * bruke metode fra collection som gir totalt antall dokumenter, da vet man hvor mange dokumenter man skal 
	 * ved  bruke next funksjonaliteten gr gjennom frste fjerdedel av dokument og de skal en ta subjektene 
	 * og legge til subjektlisten i relevantsubject, gr gjennom alle subjektene i RelevantSubjects og for 
	 * hvert subject normaliserer med vektormodellen de dokumentene som hrer til subjectet (i frste 
	 * fjerdedel)
	 * @param args
	 */
	public static void main(String[] args){
		Samling collection = new Samling();
		ArrayList ordered = new ArrayList();
		HashSet vocabularySet = new HashSet();
		//collection.addDocumentToDocumentList();
		//ordered = collection.getVocabulary().getOrderedVocabulary();
		//vocabularySet = collection.getVocabulary().getVocabulary();
		String fileName = "vocabularyAll.tmp";
		/*try{
			ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(fileName));
			out.writeObject(ordered);
			out.writeObject(vocabularySet);
		}
		catch (IOException e){
			
		}*/
		try{
			ObjectInputStream in = new ObjectInputStream(new FileInputStream(fileName));
			ordered = (ArrayList)in.readObject();
			vocabularySet = (HashSet)in.readObject();
			in.close();
		}
		catch(IOException e){
			System.out.println("e: " +e);
		}
		catch(ClassNotFoundException f){
			System.out.println("f: " +f);
		}
		System.out.println("Ferdig  lese ut vocabulary fra fil...........");
		collection.getVocabulary().setOrderedVocabualry(ordered);
		collection.getVocabulary().setVocabulary(vocabularySet);
		System.out.println("vocabulary size: " +collection.getVocabulary().getOrderedVocabulary().size());
		collection.addDocumentToDocumentList();
		PredictSubject predSubject = new PredictSubject(collection, 4);
		System.out.println(collection.getCollection().size()/4);
		predSubject.skrivResultaterTilFil();
	}
}
