/**
 * Denne klassen holder styr p alle dokumenter som hrer under dette subjectet. 
 * den tar et subject som innparameter og fordeler de dokumentene som har dette subjectet i arraylisten.
 */
import java.util.*;
public class Subject {
	private String name;
	private ArrayList documentList;
	private HashSet documentSet;
	private VektorModell enModell;
	private double[] normMeanVector;
	
	/**
	 * Konstruktr som tar inn navnet p Subject (tema) som String.
	 * Oppretter ny liste over dokumenter som dette subject innehar som ArrayList og HashSet.
	 * @param name
	 * 
	 */
	public Subject(String name){
		this.name = name;
		documentList = new ArrayList();
		documentSet = new HashSet();
	}
	/**
	 * Metode som legger et dokument til i listen over dokumenter som dette Subject innehar.
	 * @param etDokument
	 */
	public void addDocument(Document etDokument){
		if(!documentSet.contains(etDokument)){
			documentList.add(etDokument);
			documentSet.add(etDokument);
		}
	}
	/**
	 * Metode som tmmer listen og HashSettet for dokumenter.
	 *
	 */
	public void emptyDocumentsTables(){
		for(int i=0; i<documentList.size(); i++){
			Document doc = (Document)documentList.get(i);
			documentSet.remove(doc);
			documentList.remove(i);
		}
		documentList.trimToSize();
		
	}
	/**
	 * Metode som sjekker om et object er en instans av Subject.
	 * Brukes for  sjekke om en String er med i Subject.
	 * @param obj Object
	 */
	public boolean equals(Object obj){
		if(obj instanceof Subject){
			return name.equals(((Subject)obj).toString());
		}
		return false;
	}
	/**
	 * toString metode.
	 */
	public String toString(){
		return name;
	}
	/**
	 * Metode som returnerer dokumentene til subjectet som en ArrayList
	 * @return documentList ArrayList
	 */
	public ArrayList getAllDocuments(){
		return documentList;
	}
	/**
	 * Metode som setter en VektorModell for Subjectet, til bruk for  f tak i gjennomsnittsvektoren for subject.
	 * @param collection
	 */
	
	public void setVektorModell(Samling collection){
		enModell = new VektorModell(collection, this);
	}
	/**
	 * Metode som finner gjennomsnittsvektor for Subject ved  bruke deler av clustering metoden K-means
	 * @param collection Samling
	 * @return meanVector double[]
	 */
	public double[] getMeanVector(Samling collection){
		setVektorModell(collection);
		double [] meanVector = enModell.meanVektor(this);
		return meanVector;
	}
	/**
	 * Metode som normaliserer gjennomsnittsvektoren.
	 * @param collection Sanling
	 */
	public void setNormalizedMeanVector(Samling collection){
		double[] meanVector = getMeanVector(collection);
		double abs = enModell.absVektor(meanVector);
		normMeanVector = new double[meanVector.length];
		for(int i=0; i<meanVector.length; i++){
			normMeanVector[i]= meanVector[i]/abs;
		}
	}
	/**
	 * Metode som returnerer gjennomsnitts normalisert vektor for Subject.
	 * @return normMeanVector double[]
	 */
	public double[] getNormMeanVector(){
		return normMeanVector;
	}
	
		
}
