/**Klasse som inneholder ordlisten
 * @author Toril
 * @version mai 06
 */
import java.util.*;
import java.io.*;
public class Vocabulary implements Serializable {
	private ArrayList orderedVocabulary;
	private HashSet vocabulary;
	/** Konstruktor som oppretter en ny ArrayList og et HashSet
	 * 
	 */
	public Vocabulary(){
		orderedVocabulary = new ArrayList();
		vocabulary = new HashSet();	
	}
	/**
	 * Metode som legger til ordene i fra et dokument i ordlisten.
	 * @param etDocument Document
	 */
	public void addDocument(Document etDocument){
		ArrayList liste = etDocument.getTerms();
		for(int i = 0; i<liste.size(); i++){
			String streng = (String) liste.get(i);
			if(!vocabulary.contains(streng)){
				orderedVocabulary.add(streng);
				vocabulary.add(streng);
			}
		}
	}
	/**
	 * Metode som returnerer ArrayList for ordlisten
	 * @return orderedVocabulary ArrayList
	 */
	public ArrayList getOrderedVocabulary(){
		return orderedVocabulary;
	}
	/**
	 * Metode som returnerer HashSet for ordlisten
	 * @return vocabulary HashSet
	 */
	public HashSet getVocabulary(){
		return vocabulary;
	}
	/**
	 * Metode som setter ordlisten fra et ArrayList object i fil.
	 * @param fraFil ArrayList
	 */
	public void setOrderedVocabualry(ArrayList fraFil){
		orderedVocabulary = fraFil;
	}
	/**
	 * Metode som setter ordlisten fra et HashSet object i fil.
	 * @param fraFil HashSet
	 */
	public void setVocabulary(HashSet fraFil){
		vocabulary = fraFil;
	}
	/**
	 * Metode som klassen m ha for  kunne skrive objekt til fil.
	 * @param out java.io.ObjectOutputStream
	 * @throws IOException
	 */
	private void writeObject(java.io.ObjectOutputStream out)throws IOException{
	}
	/**
	 * Metode som klassen m ha for  kunne lese objekt i fra fil.
	 * @param in java.io.ObjectInputStream
	 * @throws IOException
	 * @throws ClassNotFoundException
	 */
	private void readObject(java.io.ObjectInputStream in)throws IOException, ClassNotFoundException{
	}
}
