drop table dc;
drop table free;
create table free(
     id varchar2(1024) primary key,
	 archive varchar2(256),
	 datestamp char(10),
	 groupdate number(10),
	 normdiscovery varchar2(2048),	
	 alltext long,
	subject varchar2(256)	
	);


drop table main;
create table main (
    id varchar2(1024),
    format varchar2(30),
    archive varchar2(30),
    sets    varchar(256),
    metadata long,
    timestamp char(19),
    parsed    char(1),
    primary key (id, format)
);

create table dc(
      id varchar2(1024) primary key,
      archive varchar2(256),
      datestamp char(10),
      sets varchar2(2048),
	title varchar2(2048),
	creator varchar2(2048),
	subject varchar2(2048),
	description	varchar2(4000),
	publisher varchar2(2048),
	contributor varchar2(2048),
	discovery varchar2(2048),
	type varchar2(2048),
	format varchar2(2048),
	identifier varchar2(2048),
	source varchar2(2048),
	language varchar2(2048),
	relation varchar2(2048),
	coverage varchar2(2048),
	rights varchar2(2048),
	groupdate number(10),
	normdiscovery varchar2(2048),
	discoverygroupdate number(10),
	cache char(1),
	status char(10)
	);

drop table subjectmapping;

drop table subjectschema;

drop table subjecttext;

create table subjectschema(id varchar2(30) primary key, url varchar2(255), comments varchar2(255));

create table subjectmapping (sourceschema varchar2(30),sourcecode varchar2(255),destschema varchar2(30),destcode varchar2(255), foreign key (sourceschema) references subjectschema(id),foreign key (destschema) references subjectschema(id));

create table subjecttext(schema varchar2(30),code varchar2(255), value
varchar2(255));

       
create index arc_dc_description on dc(description) indextype is ctxsys.context;
create index arc_dc_title on dc(title) indextype is ctxsys.context;
create index arc_dc_creator on dc(creator) indextype is ctxsys.context;
create index arc_dc_sets on dc(sets) indextype is ctxsys.context;
create index arc_dc_subject on dc(subject) indextype is ctxsys.context;
create index arc_dc_publisher on dc(publisher) indextype is ctxsys.context;
create index arc_dc_contributor on dc(contributor) indextype is ctxsys.context;
create index arc_dc_discovery on dc(discovery) indextype is ctxsys.context;
create index arc_dc_type on dc(type) indextype is ctxsys.context;
create index arc_dc_format on dc(format) indextype is ctxsys.context;
create index arc_dc_source on dc(source) indextype is ctxsys.context;
create index arc_dc_language on dc(language) indextype is ctxsys.context;
create index arc_dc_relation on dc(relation) indextype is ctxsys.context;
create index arc_dc_coverage on dc(coverage) indextype is ctxsys.context;
create index arc_dc_rights on dc(rights) indextype is ctxsys.context;
create bitmap index arc_dc_archive on dc(archive);
create index arc_dc_datestamp on dc(datestamp) indextype is ctxsys.context;
create bitmap index arc_dc_groupdate on dc(groupdate);
create index arc_free_alltext on free(alltext) indextype is ctxsys.context;
create bitmap index arc_free_archive on free(archive);
create bitmap index arc_free_groupdate on free(groupdate);
create  index arc_free_datestamp on free(datestamp);
drop table dpidentify;
create table dpidentify(identifier varchar(256) primary key, name varchar(255),
baseURL varchar(256), adminemail varchar(30), version varchar(10),earliestDatestamp varchar(256),deletedItem varchar(256),granularity varchar(256)); 

drop table spidentify;
create table spidentify(identifier varchar(256) primary key, name varchar(255),
baseURL varchar(256), adminemail varchar(30), version varchar(10)); 

drop table dplist;
create table dplist(identifier varchar(256) primary key, baseurl
varchar(256), active char(1), sets  varchar(100), harvestmethod
varchar(20),lastharvesttime date, metaFormat varchar(50), oaiversion
varchar(10),resumptionToken varchar(256));

drop table dpinfo;
create table dpinfo(id varchar(256) primary key, baseurl varchar(256), homepage varchar(256), name varchar(100), version varchar(10), adminemail varchar(50), delimiter char(1), sampleIdentifier varchar(100),schema char(3),datestamp char(10));

drop table querylog;
create table querylog(hostname varchar2(100), accessdate date, tablename varchar2(30),whereclause varchar2(200), sortclause varchar2(100), groupclause varchar2(100));

drop table dcnew cascade constraints;

create table dcnew(archive varchar2(256),  
                   subject varchar2(2048),
	constraint pk_dcnew primary key(archive,subject));
create index arc_dcnew_subject on dcnew(subject) indextype is
ctxsys.context;

drop table harvestlog;
create table harvestlog(inputdate varchar2(100) primary key,operation varchar2(100),source varchar2(100),destination varchar2(100),totalnum number(10),status varchar2(20),detail varchar2(100));

drop table deleterecord;
create table deleterecord(
     id varchar2(256) primary key,
	 archive varchar2(256),
	 datestamp char(10),
	 filename varchar2(256),
	 requester varchar2(256));
 
drop table scheduler;
create table scheduler(
	REQUEST_SLEEP number(8),
	HARVEST_SLEEP number(8),
    HARVEST_RANGE number(8),
    USER_AGENT varchar(100),
    HOSTNAME varchar(10));

 drop table updaterecord;
create table updaterecord(
     id varchar2(256) primary key,
     archive varchar2(256),
     datestamp char(10),
     lastharvesttime char(10),
     filename varchar2(256)
     );
drop table cache;
 create table cache(
	urlprefix varchar(255),
	dir varchar(255),
	iscache varchar(1)
);

insert into cache values('cache/','','N');
commit;





