create table free(
id varchar(255) not null,
archive varchar(255),
datestamp char(10),
groupdate int,
alltext longtext,
normdiscovery varchar(255),
subject varchar(255),
primary key(id))engine=myisam;

create table main (
    id varchar(255) not null,
    format varchar(30) not null,
    archive varchar(30),
    sets    varchar(255),
    metadata text,
    timestamp varchar(19),
    parsed char(1),
    primary key (id, format)
);
create table dc(id varchar(255) not null,
archive varchar(255),
datestamp char(255),
sets varchar(255),
title text,
creator text,
subject text,
description text,
publisher text,
contributor text,
date text,
type text,
format text,
identifier text,
source text,
language text,
relation text,
coverage text,
rights text,
groupdate int,
cache char(1),
primary key(id),
normdiscovery text,
discoverygroupdate int,
status varchar(50),
fulltext (description)
)engine = myisam;

create index tri_dc_archive on dc(archive);
create index tri_dc_sets on dc(sets);
create index tri_dc_groupdate on dc(groupdate);
create index tri_free_archive on free(archive);
create index tri_free_groupdate on free(groupdate);
create index tri_free_datestamp on free(datestamp); 

create table subjectschema(id varchar(30) primary key, url varchar(255), comments varchar(255));

create table subjectmapping (sourceschema varchar(30),sourcecode varchar(255),destschema varchar(30),destcode varchar(255), foreign key (sourceschema) references subjectschema(id),foreign key (destschema) references subjectschema(id));

create table subjecttext(schema varchar(30),code varchar(255), value
varchar(255));


create table dpidentify(identifier varchar(255) primary key, name varchar(255),
baseURL varchar(255), adminemail varchar(30), version varchar(10),earliestDatestamp varchar(255),deletedItem varchar(255),granularity varchar(255)); 

create table spidentify(identifier varchar(255) primary key, name varchar(255),
baseURL varchar(255), adminemail varchar(30), version varchar(10)); 


create table dplist
    (
	identifier varchar(255) primary key,
	virtualarchive varchar(255),
	baseurl varchar(255) NOT NULL,
	active enum('Y','N') NOT NULL,
	sets  varchar(100),
	harvestmethod enum("history_mass", "history_single",
	"fresh_mass", "fresh_single") NOT NULL ,
	lastharvesttime datetime  DEFAULT "1900-01-01",
	metaFormat varchar(50) NOT NULL DEFAULT "oai_dc",
	oaiversion enum("2.0", "1.1", "1.0") NOT NULL,
	resumptionToken varchar(255)
    )
;


create table dpinfo(id varchar(255) primary key, baseurl varchar(255), homepage varchar(100), name varchar(100), version varchar(10), adminemail varchar(50), delimiter char(1), sampleIdentifier varchar(100),schema char(3),datestamp char(10));
create table querylog(hostname varchar(100), accessdate date, tablename varchar(30),whereclause varchar(200), sortclause varchar(100), groupclause varchar(100))engine=myisam;


create table dcnew(archive varchar(100) not null, subject varchar(255) not null, constraint pk_dcnew primary key(archive,subject))engine = myisam;
create index tri_dcnew_subjec on dcnew(subject);

create table dcsubject
(
    oai_id varchar(255) NOT NULL,
    sub varchar(255) NOT NULL
);
create index dcsubject_subject on dcsubject(sub);

create table harvestlog(inputdate varchar(100) not null,operation varchar(100),source varchar(100),destination varchar(100),totalnum int,status varchar(20),detail varchar(100),primary key(inputdate));

create table deleterecord(id varchar(255) not null, archive varchar(255), datestamp varchar(10), filename varchar(255), requester varchar(255));

create table scheduler(
	REQUEST_SLEEP int,
	HARVEST_SLEEP int,
    HARVEST_RANGE int,
    USER_AGENT varchar(20),
    HOSTNAME varchar(10));

insert into scheduler values(30,1440,1,'myemail@mydomain','myhost');

create table updaterecord(
     id varchar(255) not null,
     archive varchar(255),
     datestamp char(10),
     lastharvesttime char(10),
     filename varchar(255)
     );


create table cache(
	urlprefix varchar(255),
	dir varchar(255),
	iscache varchar(1)
);
insert into cache values('cache/','','N');
commit;