package dienst;

import java.io.*;
import java.net.*;
import org.w3c.dom.*;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.SAXParseException;
import java.util.*;

/** Oct 28, 2001 by Yang Zhao
*   Remove bad records which don't obey XML rules.
*   Apply to the OAI response to ListRecords request.
*/

public class ErrorFilter extends Filter{
    private int errorLineNum;          
    //private String errorRecords;
   // private String fname = "/home/yzhao/public_html/research/errorRecords.txt";
    private File errorLog;
 
    public ErrorFilter(InputSource inputsource){
       super(inputsource);
       errorLineNum = 0;
      // errorRecords = new String("");
       //errorLog = new File(fname);  
    }
    
    
    /** locate the position of error in XML Document */

    private void checkError(){
        try {
          DocumentBuilderFactory docBuilderFactory=DocumentBuilderFactory.newInstance();
          DocumentBuilder parser = docBuilderFactory.newDocumentBuilder();
          parser.setEntityResolver(null);
          InputSource ins = new InputSource (new StringReader(xmldoc));
          Document doc = parser.parse(ins);
          errorLineNum = 0;
         
         }catch (SAXParseException err) {
          errorLineNum = err.getLineNumber();
          System.out.println("**Error is Found in: " + "line " +err.getLineNumber() + " **");
   
         }catch (SAXException se) {
            System.out.println(se);
         } catch (ParserConfigurationException pce){
            System.out.println(pce); 
         }catch (IOException ioe){
            System.out.println(ioe); 
         }
          
    }

    /** get rid of the record which contains errors
    */
    public void process () throws IOException{
         checkError();
        
         while (errorLineNum > 0){
           String xmldoc1 = "";
           String xmldoc2 = "";
           String xmldocerr = "";
           String line;
           int len;

           BufferedReader breader = new BufferedReader(new StringReader(xmldoc));
           for(int i=0; i<errorLineNum-1; i++){
               line = breader.readLine();
              xmldoc1 += line+"\n";
           } 
           
           len = xmldoc1.length();
           int s_index = xmldoc1.lastIndexOf("<record>");
           if (s_index >0){
	       xmldocerr = xmldoc1.substring(s_index, len);
              xmldoc1 = xmldoc1.substring(0, s_index);
           }
           else {
                breader.close();
                return;
           }
     
           while( (line=breader.readLine()) != null ){
              xmldoc2 += line+"\n";
           }

           len = xmldoc2.length(); 
           int e_index = xmldoc2.indexOf("</record>");

           if (e_index >=0) {
             
              xmldoc2 = xmldoc2.substring(e_index+9, len);
           }
           else {
                breader.close();
                return;
           }
           
           xmldoc = xmldoc1 + xmldoc2;
	   System.out.println("encoding error: id="+ xmldocerr.substring(xmldocerr.indexOf("<identifier>")+12,xmldocerr.indexOf("</identifier>")));

           breader.close();
           checkError();                        
         }
        
    }
    
    public void save(File file) throws IOException, FileNotFoundException{
       BufferedReader br = new BufferedReader(new StringReader(xmldoc));
       PrintWriter out = new PrintWriter(new FileWriter(file), true);
       String line;
       while( (line=br.readLine())!=null ){
         out.println(line);
       }
       br.close();
       out.close();
    }
     
 /**
    public static void main (String args[]) throws IOException,
FileNotFoundException{
       if (args.length !=2){
          System.out.println("java DocFilter [Source] [Destination]");
          System.exit(0);
        }
       String fileName = args[0];
       InputSource input = new InputSource(new FileReader(fileName));
       DocFilter docFilter = new DocFilter(input, "");
       docFilter.process();
       File file = new File(args[1]);
       docFilter.save(file);    
    }
 */
}           
