package dienst;
import java.util.*;
import java.io.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import javax.xml.parsers.*;
import org.xml.sax.helpers.*;


public class ListRecords extends Response{
    String partition;
    public String resumptionToken=null;
    String url4filter=null;
    String format=null;

    public ListRecords(DataProvider dp){
        super(dp);
    }


    public void  read(String set,String file_after,String file_before,String meta_format)throws java.io.IOException{
	String s;
    partition=set;
	if (partition==null)
	    s="";
	else
	    s="set="+URIEncoder.encode(partition);

	if (file_after!=null){
	    if (s!="")
		s=s+"&from="+file_after;
	    else
		s="from="+file_after;
	}

    if (file_before!=null){
	    if (s!="")
		s=s+"&until="+file_before;
	    else
		s="until"+file_before;
	}


	if(meta_format!=null){
            format= meta_format;
	    if (s!="")
		s=s+"&metadataPrefix="+meta_format;
	    else
		s="metadataPrefix="+meta_format;
	}
    read(dp.m_url+"?verb=ListRecords&"+s);
    url4filter=dp.m_url+"?verb=ListRecords&"+s;

	}

    /** Added by Yang Zhao. */
    public MetadataList preParse () throws IOException {
	MetadataList metadataList = new MetadataList();
        if (resumptionToken!=null){
             read(dp.m_url+"?verb=ListRecords&resumptionToken="+URIEncoder.encode(resumptionToken));
	       
         }
         resumptionToken=null;
         
         fillList (metadataList);
         return metadataList;
    }

	/**
	if (resumptionToken!=null){
             read(dp.m_url+"?verb=ListRecords&resumptionToken="+URIEncoder.encode(resumptionToken));
	       
         }
         resumptionToken=null;
         String s = getString();
         String [] sectors = s.split("<record>");
         int number = sectors.length; 
         if (number > 1){
	     if (number >2)
	        for (int i = 1; i < number - 1; i ++){
                    Metadata md = new Metadata();
                   
		    String rcd = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><record>" + sectors[i];
                    md.setMetadata(rcd);
                    
                    int id_start = rcd.indexOf("<identifier>");
                    if (id_start > 0){
		       int id_end = rcd.indexOf("</identifier>", id_start);
                       String identifier = rcd.substring(id_start+12, id_end).trim();
                       md.setIdentifier(identifier);
	            }
                    
                     md.setFormat(format);
                    md.setArchive(dp.m_id);
                    md.setSets (partition);
                    md.setTimestamp( MyClock.currentTime() );
       
                    metadataList.add(md);
		}              

	     String lastrcd = sectors[number-1];
             Metadata lmd = new Metadata();
             String [] strs = lastrcd.split("<resumptionToken>");

	     String lrcd=null;
             if (strs.length > 1){
                 lrcd = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><record>" + strs[0];

                 int k = strs[1].indexOf("</resumptionToken>");
                 resumptionToken=strs[1].substring(0, k).trim();
	     }
	     else{
                 int j = lastrcd.indexOf("</record>") + 9;
                 lrcd = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><record>"+ lastrcd.substring(0, j);
                 
	     }
             lmd.setMetadata(lrcd);
              
             int id_start = lrcd.indexOf("<identifier>");
             if (id_start > 0){
		    int id_end = lrcd.indexOf("</identifier>", id_start);
                    String identifier = lrcd.substring(id_start+12, id_end).trim();
                    lmd.setIdentifier(identifier);
	     }

             lmd.setFormat(format);
             lmd.setArchive(dp.m_id);
             lmd.setSets (partition);
             lmd.setTimestamp( MyClock.currentTime() );
       
             metadataList.add(lmd);
	 } 
 return metadataList;
	*/

	 /**
        //The following part is string-matching for preprocessing
 
        if (resumptionToken!=null){
             read(dp.m_url+"?verb=ListRecords&resumptionToken="+URIEncoder.encode(resumptionToken));
	       
         }
         resumptionToken=null;
         String s = getString();
         int index = s.indexOf("<record>");

         while (index >= 0){
	     Metadata md = new Metadata();
             md.setFormat(format);
             
             int index_end = s.indexOf("</record>", index)+9;
             String rcd = s.substring(index, index_end);
              
             int id_start = rcd.indexOf("<identifier>");
             if (id_start > 0){
		 int id_end = rcd.indexOf("</identifier>", id_start);
                 String identifier = rcd.substring(id_start+12, id_end).trim();
                 md.setIdentifier(identifier);
	     }
              
             rcd = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>"+ rcd; //Make the record be XML
             md.setMetadata(rcd);
               
             md.setArchive(dp.m_id);
             md.setSets (partition);
             md.setTimestamp( MyClock.currentTime() );

             metadataList.add(md);
             index = s.indexOf("<record>", index+8);
         }

         index = s.indexOf("<resumptionToken>");
         if (index >0){
	     int k = s.indexOf("</resumptionToken>");
             resumptionToken=s.substring(index+17, k).trim();
         }
	 return metadataList;
	 */

	/**
         // The following comment-out is SAX parsing for preprocess. 
	String savedToken = null; //In case that filtering

        if (resumptionToken!=null){
             read(dp.m_url+"?verb=ListRecords&resumptionToken="+URIEncoder.encode(resumptionToken));
	      savedToken = new String(resumptionToken); 
         }
         resumptionToken=null;
        
	 // SAXParser parser;
         SAXParserFactory factory = SAXParserFactory.newInstance();
	 MyParseHandler parseHandler = new MyParseHandler();
         factory.setValidating (false);
	 factory.setNamespaceAware(true);
         
	  boolean FAILED = true;
	  while (FAILED){
	 try{
	     SAXParser  parser = factory.newSAXParser();
	     parser.parse(super.input, parseHandler);
	     FAILED = false;

	 }catch(SAXException se){
	     System.out.println( se.getMessage());

            // We have to read the XML stream again before filtering it 
             if (savedToken!=null){
             read(dp.m_url+"?verb=ListRecords&resumptionToken="+URIEncoder.encode(savedToken));
	       
             }
             else
		 read(partition, null,null, format); 
              
             // Filter the XML 
               Filter filter = new ErrorFilter(super.input);  
	       filter.process();
	       super.input = filter.getInputSource();
                                     

	 }catch(IOException ioe){
             System.out.println(ioe.getMessage());
             FAILED = false;
	 }catch (ParserConfigurationException pce){
	     System.out.println(pce.getMessage());
             FAILED = false;
	 }
         }
	
	 return parseHandler.getList();
	*/

    
        
    private void fillList (MetadataList metadataList){
	StringBuffer tagnameBuff = new StringBuffer();
        StringBuffer recordBuff =  new StringBuffer();
        StringBuffer idBuff = new StringBuffer();
        StringBuffer tokenBuff = new StringBuffer();

        boolean CHECK_TAG=false, START_RECORD=false, START_ID=false, START_TOKEN=false;

      try{
        BufferedReader breader = new BufferedReader (
                      new InputStreamReader(input.getByteStream()) );
        int c;
        while( ( c=breader.read() ) != -1){
	    // System.out.print((char)c);
	    if ( (char)c == '<' )
                CHECK_TAG=true;
	    else if ((char)c == '>'){
                CHECK_TAG=false;
                if (tagnameBuff.toString().equals("<record")) // Note: record may have a 'status' attribute, e.g. <recod status="delete">
		    START_RECORD=true;
                else if (tagnameBuff.toString().equals("</record") && START_RECORD){
                    START_RECORD=false;
                    String rcd = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><record" + recordBuff.toString() + ">";
                    Metadata md = new Metadata();
                    md.setMetadata(rcd);

                    String identifier = idBuff.toString().trim();
                    identifier = identifier.substring(1, identifier.indexOf("<"));
                    md.setIdentifier(identifier);
 
                    md.setFormat(format);
                    md.setArchive(dp.m_id);
                    md.setSets (partition);
                    md.setTimestamp( MyClock.currentTime() );
       
                    metadataList.add(md);
                  
		    recordBuff.setLength(0);
                    idBuff.setLength(0);
		}
                else if (tagnameBuff.toString().equals("<identifier"))
		     START_ID=true;
                else if (tagnameBuff.toString().equals("</identifier"))
		     START_ID=false;

                else if (tagnameBuff.toString().startsWith("<resumptionToken"))
		     START_TOKEN=true;
                else if (tagnameBuff.toString().equals("</resumptionToken")){
		    String str = tokenBuff.toString().trim();
                    resumptionToken = str.substring(1, str.indexOf("<"));
	              START_TOKEN=false;
		}   
                
		// System.out.println(tagnameBuff.toString());
                tagnameBuff.setLength(0);
         
	    }
           
	    if (CHECK_TAG)  
		tagnameBuff.append((char)c);
            if (START_RECORD)
                recordBuff.append((char)c);
            if (START_ID)
                idBuff.append((char)c);
            if (START_TOKEN)
                tokenBuff.append((char)c);
       }

      }catch (IOException ioe){
          System.out.println(ioe);
      }
    }

    public Result parse() throws dienst.ParseException,java.io.IOException{
            RecordList recordList=new RecordList();

            if (resumptionToken!=null){
                read(dp.m_url+"?verb=ListRecords&resumptionToken="+URIEncoder.encode(resumptionToken));
		url4filter=dp.m_url+"?verb=ListRecords&resumptionToken="+URIEncoder.encode(resumptionToken);
            }
            resumptionToken=null;

 /* Jan 10, 2002 Added by Yang Zhao
 * Filter */
           
             

          /////////////////////////////////////////////////
	      Element e=null;
	      try{
		  e= super.validate();
	      }
	      catch (Exception ex){
		  //read again, ugly processing. Lazy to change whole structure.
		  //Probably will arise resumptionToken confuse in data provider side
		  read(url4filter);
		      ErrorFilter filter = new ErrorFilter(super.input);  
		      filter.process();
		      super.input = filter.getInputSource(); 
		      e=super.validate();
		  }
	    

            NodeList n=e.getChildNodes();
            Node recordElement=null;
            //find oams record
          String errorReport="";
            for (int i=0;i<n.getLength();i++){
                recordElement=n.item(i);
                if (recordElement.getNodeType()==Node.ELEMENT_NODE)
                    if (((Element)recordElement).getTagName().equals("record")){
                        try{
                            Record r=null;
                            r=MetaParser.parseOAMS((Element)recordElement);
                            if (r!=null){
				if (partition!=null){
				    r.m_sets=dp.m_partitionList.getSpecByName(partition);
				}
   		r.m_archive=dp.m_id;
				recordList.add(r);
                            }
                        }
                        catch(Exception ex){
                            System.out.println(ex);
                        }
                    }
                    else if (((Element)recordElement).getTagName().equals("resumptionToken")){
                        resumptionToken= MetaParser.fetchChild((Element)(recordElement));

                    }
            }
        return recordList;
    }

    public String getResumptionToken(){
        return resumptionToken;
    }


    /**
class MyParseHandler extends DefaultHandler{
    MetadataList metadataList;
    Metadata md =null;
    String record=null;
    String identifier="";
    String setList = "";
    boolean recordFlag = false;
    boolean tokenFlag = false;
    boolean idFlag = false;
    boolean setFlag = false;

    MyParseHandler (){
	super();
	metadataList = new MetadataList();
    }
    
    public void startElement(String uri, String localName, String rawName, Attributes atts)
           throws SAXException{
	if (localName.equals("record")){
            record = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>";
            recordFlag = true;
            md = new Metadata();
            md.setFormat(format);
            md.setArchive(dp.m_id);
	}
        if (localName.equals("resumptionToken"))
            tokenFlag = true;

        if (recordFlag){
	    record += "<"+ localName + ">";

	    if(localName.equals("identifier"))
	         idFlag = true;
	    if(localName.equals("setSpec"))
		  setFlag = true;

        }

    }

    public void endElement (String uri, String localName,String rawName) throws SAXException {
        if (recordFlag){
          record += "</"+ localName + ">";
	}
	if (localName.equals("record")){
	    // System.out.println(record);
            md.setMetadata(record);
	    recordFlag = false;
           
            md.setIdentifier(identifier);
            identifier = "";
            md.setSets (setList);
            setList = "";
            metadataList.add(md);
	    md =null;
	}
        if(localName.equals("identifier"))
	    idFlag = false;
        if(localName.equals("setSpec"))
	    setFlag = false;

	if (localName.equals("resumptionToken"))
	    tokenFlag = false;
    }

    public void characters (char[] ch, int start, int end) throws SAXException {
	String s = new String (ch, start, end);
        s= s.trim();
        if (recordFlag){
	    record += s;
	}
        if (idFlag)
	    identifier = s;
        if (setFlag){
            String setname = dp.m_partitionList.getSpecByName(s);
            if (setList.length() == 0)
                setList += setname;
             else
	        setList += " | " + setname;
	} 
        if (tokenFlag)
	    resumptionToken = s;

    }
   
	public MetadataList getList(){
	    return metadataList;
	}
   
 }

    */

}
  










