package dienst;
import java.io.File;
import java.io.*;
import java.net.*;
import org.w3c.dom.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.*;
import java.util.*;


public abstract class Response {
    DataProvider dp;
    InputSource input;
    String requesturl=null;

    public Response(DataProvider dp){
        this.dp=dp;
    }


    public void read(File f) throws java.io.FileNotFoundException{
        input=new InputSource(new FileReader(f));
    }

    public void read(String url) throws java.io.IOException{
	//To avoid rapid Fire request 
	try{ 
	    Thread.sleep(Config.SLEEP_BETWEEN_REQUEST*1000); 
	} 
	catch (Exception sleepe){ 
	    System.out.println(sleepe); 
	}
 
        requesturl=url;
        URL u=new URL(requesturl);
        Date today=new Date();
        System.out.println(requesturl+" "+today);
        HttpURLConnection conn=null;
	//will try at least three times whatever is wrong.
	int count=0;
        for(;;){
            try{
		count++;
                conn=(HttpURLConnection)u.openConnection();
                conn.setRequestProperty("User-Agent",Config.AGENT);
                input=new InputSource(conn.getInputStream());
                System.out.println("responsecode:"+ conn.getResponseCode ());
                break;
            }
            catch(IOException e){
		System.out.println(e);
                System.out.println("responsecode:"+ conn.getResponseCode ());
                if ((conn.getResponseCode ()==503)&&(conn.getHeaderField ("Retry-After")!=null)){
                    int sleeptime=Integer.parseInt (conn.getHeaderField ("Retry-After"));
                    try{
                        System.out.println("503 error retry: sleep "+sleeptime+" seconds");
                        Thread.sleep (sleeptime*1000);
                    }
                    catch(Exception ex){
                    }
                }
		else if (count<3){
		    continue;
		}
		else
                   throw e;
            }
	    
	  
	 
        }
    }


    public void print(){
    }
    
    //public Result preParse() throws ResponseException;

    public abstract Result parse() throws dienst.ParseException,java.io.IOException,ResponseException;

    
    Element  validate() throws IOException,dienst.ParseException{
	try {


	    DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.
	    							newInstance();
	    DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
        docBuilder.setEntityResolver(null);
	    Document doc = docBuilder.parse (input);
	    // normalize text representation
	    doc.getDocumentElement ().normalize ();
        Element e=doc.getDocumentElement();
        return e;

	} catch (SAXParseException err) {
        throw new ParseException("** Parsing error"
		+ ", line " + err.getLineNumber ()
		+ ", uri " + err.getSystemId ());
	    // print stack trace as below

	} catch (SAXException e) {
        throw new ParseException(e.getMessage());

	}
    catch (Throwable t) {
	    throw new ParseException(t.getMessage());
	}
 }

    public  void write(File f) throws IOException{

        URLConnection conn=(new URL(requesturl)).openConnection();
        conn.setRequestProperty("User-Agent","liu_x@cs.odu.edu");
        conn.connect();
        InputStream in =conn.getInputStream();
        BufferedReader dataIn=new BufferedReader(new InputStreamReader(in));

        FileWriter writer=new FileWriter(f);
        String line;
        while((line=dataIn.readLine())!=null){
                writer.write(line+"\n");
        }
        dataIn.close();
        writer.flush();
        writer.close();
    }

    String getString(){
      String xmldoc = "";
      try{
       BufferedReader breader = new BufferedReader (
                      new InputStreamReader(input.getByteStream()) );
       String line;
      
       while( (line=breader.readLine()) != null ){
         xmldoc += line;
       }

      }catch (IOException ioe){
          System.out.println(ioe);
      }
      return xmldoc;
    }
}









