package ns.ldap;

import java.io.*;
import java.sql.*;
import java.util.*;

import ns.*;

/**
 * This class fetches data provider list from database.
 *
 * database schema: create table dplist(identifier varchar(20) primary key, baseurl varchar(100), active char(1),
 * harvestmethod varchar(20));
 * Used by Harvesting Tools.
 *
 * Author xiaoming Liu (liu_x@cs.odu.edu)
 */

public class LDAPDPReader implements NameList
{
    // private Hashtable list;
      private Vector list;
    /**
     * Default Constructor --
     * Construct a new data provider reader that inherits Hashtable class
     *
     */
    public LDAPDPReader()
    {
         list=new Vector();
    }


    /**
     * Parsing the specified XML document containing the information of data providers
     *
     * @param xmlUri the uri of XML document
     * @return None
     */
    public void init() {
        try{
            NameServer ns=new NameServer();
            Vector v=ns.query("","",true);

            for(Enumeration enum=v.elements();enum.hasMoreElements();){
                User user=(User)enum.nextElement ();
		System.out.println(user.id);
		// list.put(user.id,user);
                list.add(user);
            }

        }catch(Exception e){
            System.out.println(e);
        }
    }

    /**
     * Return parse results
     */

     public Vector getNameList(){
        return list;
     }

     private void removeAll(){
        try{
            NameServer ns=new NameServer();
            Vector v=ns.query("","",true);
            for(Enumeration enum=v.elements();enum.hasMoreElements();){
                User user=(User)enum.nextElement ();
                if (user.id.indexOf ("'")!=-1)
                    ns.deleteUser (user.id);
            }

            v=ns.query("","",false);
            for(Enumeration enum=v.elements();enum.hasMoreElements();){
                User user=(User)enum.nextElement ();
                ns.deleteUser (user.id);
            }


        }catch(Exception e){
            System.out.println(e);
        }

     }


    /**
     * This main function demonstrates class DPReader
     * @param args the URI of the XML document
     * @return None
     */
    public static void main(String args[]) throws java.lang.Exception
    {

    	LDAPDPReader dpr = new LDAPDPReader();
        dpr.init();
	// for (Enumeration keys = dpr.getNameList().keys(); keys.hasMoreElements();)
	//  System.out.println(dpr.getNameList().get(keys.nextElement()));

        for (Enumeration keys = dpr.getNameList().elements(); keys.hasMoreElements();)
	   System.out.println(keys.nextElement());
	    //        dpr.addAll();

    }

     private void addAll(){
         try{
            NameServer ns=new NameServer();
            ns.addUser("zubair@odu","http://128.82.4.224:2048/oai",true);
            ns.addUser("sss","http://128.82.4.149:2048/oai",true);
            ns.addUser("stuartsnikautestcollection","http://130.217.248.92:2048/oai",true);
            ns.addUser ("Stanford DLI2","http://171.64.75.199:2048/oai",true);
            ns.addUser("kmaly@odu","http://128.82.4.207:261/oai",true);

        }catch(Exception e){
            System.out.println(e);
        }
     }
}
