package ns.ldap;
import java.io.*;
import java.text.*;
import java.net.*;
import java.util.*;
 
import javax.naming.*;
import javax.naming.directory.*;


public class NameServer{

  Connect conn ;
  BufferedReader br;
  DecimalFormat df;
  Number n;

  Date now;
  Calendar cal;
  long time;

public  NameServer() throws NamingException
 {
     conn = new Connect();
 }


 // all parameters except 'status' are compulsory here
 public boolean addUser(String UserName,  String baseURL, boolean status)
 {
   if(UserName.length()==0  || baseURL==null)
   {
     System.out.println("Invalid parameters passed");
     return false;
   }
   try
   {
     String obj = new String();
     Attributes attribs1 = new BasicAttributes(true); // ignore case
     obj = UserName+"ENTRY OBJECT";
     attribs1.put(new BasicAttribute("name",UserName));
     // check if "cn="+str already exists

     if(conn.boolSearch(attribs1))
     {
       System.out.println("User already exists");
       return false;
     }
     // get remaining attributes
     attribs1.put(new BasicAttribute("name",UserName));
     attribs1.put(new BasicAttribute("baseURL",baseURL));
     if (status)
         attribs1.put(new BasicAttribute("status","on"));
     else
         attribs1.put(new BasicAttribute("status","off"));


     cal = Calendar.getInstance();
     String str = cal.getTime().toString();

     attribs1.put(new BasicAttribute("lastlogin",str));
     attribs1.put(new BasicAttribute("registertime",str));
     attribs1.put(new BasicAttribute("lastlogout",str));

     conn.bindObject("cn"+UserName,obj,attribs1);
     System.out.println("Registration of USER : "+UserName+" complete.....");
     return true;
   }catch (NamingException e)
    {
       System.err.println("bind failed. " + e);
       return false;
    }
 }

 // All parameters are compulsory here
 public boolean deleteUser(String UserName)
 {
   if(UserName.length()==0)
   {
     System.out.println("Invalid UserName");
     return false;
   }

   try
   {
     Attributes attribs1 = new BasicAttributes(true); // ignore case
     attribs1.put(new BasicAttribute("name",UserName));
     // check if "cn"+str exists
     if(!conn.boolSearch(attribs1))
     {
       System.out.println("User does not exist");
       return false;
     }

     conn.unbindObject("cn"+UserName);
     System.out.println("Unbinding of USER : "+UserName+" complete.....");
     return true;
   }catch (NamingException e)
    {
      System.err.println("Unbind bind failed. " + e);
      return false;
    }
 }


 // use string of length zero if you are not interested in searhing on any attribute
 // none of the parameters are compulsory here. If all the parameters are of lenght =0
 // All the users in the registry are returned.
 public Vector query(String UserName, String baseURL, boolean status)
 {

   Vector result = new Vector();
   User usr = new User();

   Attributes attribs1 = new BasicAttributes(true); // ignore case

   if(UserName.length() > 0)
   {
     attribs1.put(new BasicAttribute("name",UserName));
   }

   if(baseURL.length() > 0)
   {
     attribs1.put(new BasicAttribute("baseURL",baseURL));
   }


   if(status)
   {
     attribs1.put(new BasicAttribute("status","on"));
   }
   else
     attribs1.put(new BasicAttribute("status","off"));


   // print the attributes
   //conn.SearchRetAll(dctx,attribs1);

   // new code
   Attributes attribs2 = new BasicAttributes(true); // ignore case
   NamingEnumeration ae = conn.SearchRetAttribs(attribs1);
   try
   {
     if( !ae.hasMore())
     {
       System.out.println("User : "+UserName+" not available ");
       return result;
     }

     while(ae.hasMore())
     {
       SearchResult sr = (SearchResult)ae.next();
       attribs2 = sr.getAttributes();
       if( attribs2 != null)
       {
         try
         {
           usr = new User();
           for( NamingEnumeration ae1 = attribs2.getAll(); ae1.hasMore();)
           {
             try
             {
               Attribute attr = (Attribute)ae1.next();
               String nam = (String)attr.getID();
               String val = new String();
               //System.out.println("attribute: " + nam);
               NamingEnumeration e = attr.getAll();
               if( e.hasMore())
               {
                 try  // to get rid of cast exception
                 {
                   val = (String)e.next();

                   // collect attributes
                   if(nam.equalsIgnoreCase("name"))
                   {
                     usr.id = val;
                   }
                   if(nam.equalsIgnoreCase("baseURL"))
                   {
                     usr.baseURL = val;
                   }
                   if(nam.equalsIgnoreCase("registertime"))
                   {
                     usr.RegisterTime = val;
                   }
                   if(nam.equalsIgnoreCase("lastlogin"))
                   {
                     usr.LastLogin = val;
                   }
                   if(nam.equalsIgnoreCase("lastlogout"))
                   {
                     usr.LastLogout = val;
                   }
                   if(nam.equalsIgnoreCase("status"))
                   {
                     if (val.equals("on"))
                         usr.active = true;
                     else
                        usr.active=false;
                   }
                 }catch(Exception exp)
                  {
                    //System.out.println("Not a String");
                    val = "NoEntry";
                  } 
                 //System.out.println("value: " +val );
               }
               else
               { 
                 val = "NoEntry";
                 //System.out.println("No Value");   
               }  
             }catch(Exception e22)
              {
                System.out.println("Exception in Query in for loop : "+e22);
              }
           }// end of for loop
           if(usr.id.length()!=0)
           {
             result.add(usr);
           }
         }catch (Exception e33)
          {
            System.out.println("Exception in Query at for loop : "+e33);
          }
       }
     }
   }catch(Exception e11)
    {
       System.out.println("Exception in Query at ae.hasMore () : "+e11);
       return result;
    }
   return result;
 }

//username is compulsory
 public boolean modifyUser(String UserName,String baseURL, boolean status)
 {
   if(UserName.length()==0 )
   {
     System.out.println("Invalid paramenters passed");
     return false;
   }

   try
   {
     String str = new String();
     Attributes attribs1 = new BasicAttributes(true); // ignore case
     attribs1.put(new BasicAttribute("name",UserName));

     Attributes attribs2 = new BasicAttributes(true); // ignore case
     NamingEnumeration ae = conn.SearchRetAttribs(attribs1);
     if( !ae.hasMore())
     {
       System.out.println("User : "+UserName+" not available");
       return false;
     }

     SearchResult sr = (SearchResult)ae.next();
     attribs2 = sr.getAttributes();

     if( attribs2 == null)
     {
       System.out.println("No Attributes available");
       return false;
     }

     String lastlogin = new String();
     String lastlogout = new String();
     String registertime = new String();

     for ( ae = attribs2.getAll(); ae.hasMore();)
     {
       Attribute attr = (Attribute)ae.next();
       String nam = (String)attr.getID();
       String val = new String();
       System.out.println("attribute: " + nam);
       NamingEnumeration e = attr.getAll();
       if( e.hasMore())
       {
         try  // to get rid of cast exception
         {
           val = (String)e.next();
         }catch(Exception exp)
          {
            System.out.println("Not a String");
            val = "NoEntry";
          }
         System.out.println("value: " +val );
       }
       else
       {
         val = "NoEntry";
         System.out.println("No Value");
       }

       // collect attributes
       if(nam.equalsIgnoreCase("registertime"))
       {
         registertime = val;
       }
       if(nam.equalsIgnoreCase("lastlogin"))
       {
         lastlogin = val;
       }
       if(nam.equalsIgnoreCase("lastlogout"))
       {
         lastlogout = val;
       }
     }

     //Enter the modified attributes
     cal = Calendar.getInstance();
     str = cal.getTime().toString();

     if(status)
        lastlogin=str;
     else
        lastlogout=str;


     attribs1 = new BasicAttributes(true); // ignore case
     attribs1.put(new BasicAttribute("name",UserName));
     attribs1.put(new BasicAttribute("baseURL",baseURL));
     if (status==true)
         attribs1.put(new BasicAttribute("status","on"));
     else
         attribs1.put(new BasicAttribute("status","off"));



     attribs1.put(new BasicAttribute("lastlogin",lastlogin));
     attribs1.put(new BasicAttribute("registertime",registertime));
     attribs1.put(new BasicAttribute("lastlogout",lastlogout));

     str = UserName+"User Details Object";
     conn.bindObject("cn"+UserName,str,attribs1);
     System.out.println("User: "+UserName+" detais modified...");
     String obj1 = (String)conn.getObject("cn"+UserName);
     System.out.println("Success.....Here is the object i obtained from LDAP");
     System.out.println(obj1);
     return true;
   }catch (NamingException e)
    {
      System.err.println("bind failed. " + e);
      return false;
    }
 }
};













