package scheduler;

import dienst.*;
import java.io.*;
import java.util.*;
import java.text.*;


import db.*;
import ns.*;
import ns.ldap.*;

/**
 * Harvest OAI compliant Data Provider
 *
 *@author xiaoming liu
 */


public class Harvest {

//Scheduler
    Scheduler s=null;
    ConnectionPool m_connectionPool=null;
    /**
      * Constructor
      */
    public Harvest(){}


    /**
      * Initialization, including three steps
      * 1. Load Database configuration under conf/ConnectionPool.cfg
      * 2. Load Data Provider List under conf/dps.xml
      * 3. Load other properstires under conf/setup.cfg
      */

    public void init(){
	m_connectionPool=new ConnectionPool();
	try{
	    m_connectionPool.initialize();
	}
	catch(Exception ex){
	    ex.printStackTrace();
	}
        // initailize harvest parameter
        Config c=new Config(m_connectionPool);

        //load database configuration and create connection Pool
        s=new Scheduler(c, m_connectionPool);

    }


    /**
     * main function
    */

   public static void main(String args[]) {
       if ((args.length ==1)  && args[0].equals("--help"))
    {
      System.err.println("Usage:");
      System.err.println("  java scheduler/Harvest" +
                         " [-i] [-t]\n  -i\n\t Do reindex only \n  -t\n\t Enable internal timer\n");
      System.exit (1);
    }
       Vector params=new Vector();
       for (int i=0;i<args.length;i++){
	   params.add(args[i]);
       }

       
       Harvest harvester=new Harvest();
       harvester.init();
       
       if (params.contains("-t")){
	   System.out.println("Start Harvester with internal timer");
	   harvester.s.timerOn();
       }
	
       if (params.contains("-i")){
	   System.out.println("Start Reindex database, please wait");
	   harvester.s.reindex(); 
	   System.out.println("Reindex is done");	
	   System.exit(0);
	   
       }      
       else{
	   System.out.println("Start to Harvest");
	   harvester.s.harvest();
	   System.exit(0);
       }
       
   }

}

