package arc20;

import java.io.*;
import java.util.*;
import java.sql.*;

import db.*;
import dataprovider20.*;


public abstract class SimpleIdentity implements dataprovider20.Identity {
//these fields are loaded from property file
    String name;
    String OAIversion;

    //info for identify
    String adminemail;
    String id;
    String earliestDatestamp;
    String deletedItem;
    String granularity;


    //baseurl
    String baseurl;

    ConnectionPool m_connectionPool=null;
    Connection connection=null;
    //connection pool

    /**
     *Constructor
     *@param cpool COnnection pool
     */

    public SimpleIdentity(ConnectionPool cpool){
        m_connectionPool=cpool;
        loadConfig();
    }


    public String getOAIversion(){
        return OAIversion;
    }

    public String getBaseURL(){
        return baseurl;
    }

    public String getName(){
        return name;
    }

    public String getID(){
        return id;
    }

    public String getDelimiter(){
        return ":";
    }

    public String getSampleIdentifier(){
        return "oai:arc.cs.odu.edu:tr-101";
    }
    public String getSchema(){
        return "oai";
    }

    public String getAdminemail(){
        return adminemail;
    }
    
    public String getEarliestDatestamp(){
	return earliestDatestamp;
    }

    public String getDeletedItem(){
	return deletedItem;
    }
    
    public String getGranularity(){
	return granularity;
    }


     private void loadConfig(){
        Statement s=null;
        try{
             connection=m_connectionPool.getConnection();
             s=connection.createStatement();
             ResultSet rs= s.executeQuery("select * from "+getTableName());
             if (rs.next()){
                 id=rs.getString("identifier");
                 name=rs.getString("name");
                 baseurl=rs.getString("baseURL");
                 adminemail=rs.getString("adminemail");
                 OAIversion=rs.getString("version");
		 earliestDatestamp=rs.getString("earliestDatestamp");
		 deletedItem=rs.getString("deletedItem");
		 granularity=rs.getString("granularity");
             }
        }
        catch (SQLException e){
            System.out.println(e);
        }
        finally{
            try{
                s.close();
                m_connectionPool.close(connection);

            }
            catch(Exception e){
                System.out.println(e);
            }
        }

    }

    public abstract String getTableName();

}
