package log;

import oairequester.Result;

import java.util.*;
import java.text.*;
/**
 * details of each log record
 */
public class LogRecord implements Result {
    /** input date */
    public Date m_inputdate=Calendar.getInstance().getTime();
    /** operation */
    public String m_operation=""; 
    /** source */
    public String m_source="";
    /** destination */
    public String m_destination="";
    /** status */
    public String m_status="Sending";
    /** total number */
    public int m_totalnum=0;
    /** detail */
    public String m_detail="";
    /** flag set if harvest time is updated */
    public boolean m_updateharvesttime=false;
    /** 
     * contructor of a new LogRecord
     * @param inputdate the input date
     * @param operation the operation
     * @param source source
     * @param detination the destination
     * @param updateharvesttime flag to set if harvest time is updated
     */
    public LogRecord(Date inputdate, String operation, String source, String destination, boolean updateharvesttime) {
	m_inputdate = inputdate;
	m_operation = operation;
	m_source = source;
	m_destination = destination;
	m_updateharvesttime = updateharvesttime;
 
    }
    /**
     * Convert the log record to a string
     */
    public String toString() {
	String temp = "inputdate = " + m_inputdate + " operation=" + m_operation + " source= " + m_source + " destination=" + m_destination + "status=" + m_status + "totalnum=" + Integer.toString(m_totalnum) + " detail = " + m_detail;
	return temp;
    }

}
