package ns;

import java.io.*;
import java.sql.*;
import java.util.*;
import java.text.*;


import db.*;
/**
 * This class fetches cache configuration from database.
 *
 * database schema: create table cache(
	urlprefix varchar(255),
	dir varchar(255),
	iscache varchar(1)
);
 * Used by Harvesting Tools and search result display.
 *
 * Author xiaoming Liu (liu_x@cs.odu.edu)
 */

public class CacheCfg
{
    ConnectionPool m_connectionPool;
    
    public CacheCfg(ConnectionPool cpool)
    
    {
	m_connectionPool=cpool;
	
    }
    public Cache getCache(){
        Statement stmt=null;
	Cache cfg=new Cache();
	String sql = null;
	Connection connection=null;
        try{
	    connection=m_connectionPool.getConnection();
            stmt=connection.createStatement();
	    try{
		sql="select urlprefix,iscache,dir from cache";
		ResultSet rs=stmt.executeQuery(sql);		
		if (rs.next()){
		    cfg.urlprefix=rs.getString(1);
		    cfg.iscache=rs.getString(2);
		    cfg.dir=rs.getString(3);
		}
		    
		else
		    cfg.iscache="N";	       		
		rs.close();
            }
            catch(Exception ex){
		System.out.println(ex);
            }
	    
        }
        catch (SQLException e){
            System.out.println(e);
        }
        finally{
            try{
                stmt.close();
		m_connectionPool.close(connection);
            }
            catch(Exception e){
                System.out.println(e);
            }
        }
	return cfg;

    }
    
}
