package ns.ldap;
import java.io.*;
// to understand this go to www.java.sun.com/jndi/tutorial/
// you will have to learn simple aspects of ldap and then 
//JNDI basics to understand this code

import java.net.*;
import java.util.Hashtable;
import java.text.*;
import javax.naming.*;
import javax.naming.directory.*;

/**
 * connect to the server and its utilities
 */
class Connect
{
  private Hashtable env;
  private DirContext dctx;

    /** This part will connect to the NetScape Server.*/
  Connect() throws NamingException
  {
    env = new Hashtable() ; //5,0.75f);
    env.put(Context.INITIAL_CONTEXT_FACTORY, "com.sun.jndi.ldap.LdapCtxFactory");
    env.put(Context.PROVIDER_URL,"ldap://alvin.secure.research.odu.edu:389/o=secure.research.odu.edu");
    env.put(Context.SECURITY_AUTHENTICATION, "simple");
    env.put(Context.SECURITY_PRINCIPAL, "cn=Directory Manager");
    env.put(Context.SECURITY_CREDENTIALS, "bigapple");
    env.put(Context.OBJECT_FACTORIES, "ConnectionFactory");
    env.put(Context.OBJECT_FACTORIES, "UserFactory");
    // env.put("com.sun.jndi.ldap.trace.ber", System.err);
    //env.put(Context.REFERRAL, "follow");
    env.put("com.sun.naming.netscape.schemaBugs", "true");
    dctx = new InitialDirContext(env);
  }


    /**  special operatons ............*/

  public DirContext getdContext(){
     return dctx;
  }
    /**  special operatons ............*/

  public DirContext changeDir(String str) throws NamingException{
     return (DirContext)dctx.lookup(str);
  }


    /**binding operations...........................*/


  public void bindObject(String str, Object o) throws NamingException{
	dctx.rebind(str, o);
  }
    /**binding operations...........................*/

  public void bindObject(String str, Object o, Attributes attrs) throws NamingException{
	dctx.rebind(str, o,attrs);
  }



    /** bind renaming oprations................*/

  public void renameObject(String old_name, String new_name) throws NamingException{
	dctx.rename(old_name,new_name);
  }



    /** Object Unbinding operations....................*/

  public void unbindObject(String str) throws NamingException{
      dctx.unbind(str);
  }




    /**   get object ( object lookup ) functions.....................*/

  public Object getObject(String str) throws NamingException {
     return dctx.lookup(str);
  }



// other operations..............................
    /** modify attributes */

  public  void ModAttribs( String str,int var, Attributes orig) throws NamingException
  {
    if ( var == 1)
        dctx.modifyAttributes(str,DirContext.ADD_ATTRIBUTE,orig);
    else if ( var==2)
            dctx.modifyAttributes(str,DirContext.REMOVE_ATTRIBUTE,orig);
         else if ( var==2)
                 dctx.modifyAttributes(str,DirContext.REPLACE_ATTRIBUTE,orig);
  }
    /** modify attributes */
  public  void ModAttribs( String str,ModificationItem[] attribs) throws NamingException {
     dctx.modifyAttributes(str,attribs);
  }

    /** print attributes*/
  public static void printAttrs(Attributes attrs)
  {
    //System.out.println(" i have entered actual printing stage....");
    if (attrs == null)
    {
      System.out.println("No attributes");
    }
    else
    {
      try
      {
        // System.out.println("should be printing");
        for (NamingEnumeration ae = attrs.getAll(); ae.hasMore();)
        {
          Attribute attr = (Attribute)ae.next();
          System.out.println("attribute: " + attr.getID());
          for (NamingEnumeration e = attr.getAll(); e.hasMore();)
          {
            System.out.println("value: " + e.next());
          }
        }
      } catch (NamingException e) {
        e.printStackTrace();  }
    }
    System.out.println("done with printing"); 
  }
    /**print search enumeration*/
  public static void printSearchEnumeration(NamingEnumeration enum)
  {
    try
    {
      //System.out.println(" i am printting ");
      while (enum.hasMore()) 
      {
         System.out.println(" i entered  printSearchEnumeration");
         SearchResult sr = (SearchResult)enum.next();
         System.out.println(">>>" + sr.getName());
         printAttrs(sr.getAttributes());
      } 
      //System.out.println(" i did end");
    } catch (NamingException e) {
      e.printStackTrace();}
  }

      
    /** search and return all*/
  public void SearchRetAll(String name, String value)
  {
    try
    {
      Attributes matchAttrs = new BasicAttributes(true); // ignore case
      matchAttrs.put(new BasicAttribute(name,value));

      // Search for objects with those matching attributes
      NamingEnumeration answer = dctx.search("", matchAttrs);  
                 
      System.out.println(" Searching Results ........"); 
      printSearchEnumeration(answer);
    
    } catch (Exception e) {
        e.printStackTrace(); }
  }
    /** search and return all*/
  public void SearchRetAll(Attributes matchAttrs)
  {
    try
    {
      // Search for objects with those matching attributes
      NamingEnumeration answer = dctx.search("", matchAttrs);

      System.out.println(" Searching Results ........");
      printSearchEnumeration(answer);

    } catch (Exception e) {
        e.printStackTrace(); }
  }
    /** search class */
  public NamingEnumeration SearchRetClass(String cstrType, String cstr )
  {
    NamingEnumeration answer = null;
    try
    {
      Attributes matchAttrs = new BasicAttributes(true); // ignore case
      //matchAttrs.put(new BasicAttribute("class",cstr));
      matchAttrs.put(new BasicAttribute(cstrType,cstr));
      answer = dctx.search("",matchAttrs);
    } catch (Exception e) {
         e.printStackTrace();}
    return answer;
  }
    /** search attributes*/
  public NamingEnumeration SearchRetAttribs(Attributes matchAttrs )
  {
    NamingEnumeration answer = null;
    try
    {
      answer = dctx.search("",matchAttrs);
    } catch (Exception e) {
         e.printStackTrace();}
    return answer;
  }

    /** boolean search*/
  public boolean boolSearch(Attributes matchAttrs)
  {
    try
    {
      //System.out.println(" Entered boolean search ");
      NamingEnumeration answer = dctx.search("",matchAttrs);

      if(answer.hasMore())
      {  return true;  }

      //System.out.println(" OK upto boolean serach ");
    } catch (Exception e) {
        e.printStackTrace();}
    return false;
  }

 /* // function to print list of attributes
  public void attribs4(String[] names)
  {
     for( int i=0;i< names.length ;i++)
     {
       try
       {
         Attributes answer = RdAttribs(names[i]);
	   for ( NamingEnumeration ae = answer.getAll(); ae.hasMore();)
         {
	     Attribute attr = (Attribute)ae.next();
           System.out.println("attribute = "+ attr.getID() );
           //printing each value
           for ( NamingEnumeration be = attr.getAll();be.hasMore();)
	     System.out.println("value = "+ be.next() ) ;
	     System.out.println("\n" ) ;
	   }
	 }catch (NamingException e) {
	   System.err.println("attribute read failed. " + e);}
     }
   } */
};





