package oairequester;
import java.util.*;
import java.io.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import javax.xml.parsers.*;
import org.xml.sax.helpers.*;

public class GetRecord extends Response{
    String format=null;
    String identifier=null;
    public GetRecord(DataProvider dp){
        super(dp);
    }

    public void read(String fullID,String meta_format) throws java.io.IOException{
        read(dp.m_url+"?verb=GetRecord&identifier="+fullID+"&metadataPrefix="+meta_format);
        format = meta_format;
        identifier=fullID;
    }

   /** Added by Yang Zhao. */
    public Metadata preParse () throws IOException {
 
	//The following is string-matching for preprocessing 
         Metadata md = null;
         String s = getString();
         int index = s.indexOf("<record>");
         if (index > 0){
	     md = new Metadata();
             md.setFormat(format);
             
             int index_end = s.indexOf("</record>", index)+9;
             String rcd = s.substring(index, index_end);
              
             int id_start = rcd.indexOf("<identifier>");
             if (id_start > 0){
		 int id_end = rcd.indexOf("</identifier>", id_start);
                 String identifier = rcd.substring(id_start+12, id_end).trim();
                 md.setIdentifier(identifier);
	     }
              
             /*int meta_start = rcd.indexOf("<metadata>");
             if (meta_start > 0){
		 int meta_end = rcd.indexOf("</metadata>", meta_start);
                 String metadata = rcd.substring(meta_start, meta_end+11);
                 md.setMetadata(metadata);
		 } */
             rcd = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" + rcd;
	     md.setMetadata(rcd);

             md.setArchive(dp.m_id);
             md.setTimestamp( MyClock.currentTime() );
         }         
         return md;
	/** //The following is SAX parsing for preprocessing
         SAXParser parser;
         SAXParserFactory factory = SAXParserFactory.newInstance();
	 MyParseHandler parseHandler = new MyParseHandler();
         factory.setValidating (true);
	 factory.setNamespaceAware(true);
	 try{
	     parser = factory.newSAXParser();
	     parser.parse(input, parseHandler);
	 }catch(SAXException se){
	     System.out.println(se.getMessage());
	 }catch(IOException ioe){
             System.out.println(ioe.getMessage());
	 }catch (ParserConfigurationException pce){
	     System.out.println(pce.getMessage());
	 }
         
	 return parseHandler.md;
	*/
    }
    
    /** End of Add */

    public Result parse() throws ParseException,java.io.IOException, ResponseException{
        Record r=null;
        try{
            Element e= super.validate();
            NodeList n=e.getChildNodes();
            Element recordElement=null;

            //find oams record
            for (int i=0;i<n.getLength();i++){
                if (n.item(i).getNodeType()==Node.ELEMENT_NODE){
                    recordElement=(Element)(n.item(i));
                    if ((recordElement.getTagName()).equals("record"))
                        break;
                }
            }

            if (recordElement == null)
                throw new NoRecordException("");
            r= MetaParser.parseOAMS(recordElement);
            r.m_archive =dp.m_id;
        }
        catch (NoRecordException exception){
            throw new NoRecordException(requesturl+"'s response does not have record");
        }
        return r;
    }

    /**
class MyParseHandler extends DefaultHandler{
    // MetadataList metadataList;
    Metadata md =null;
    String record=null;
    String identifier="";
    String setList = "";
    boolean recordFlag = false;
    // boolean tokenFlag = false;
    boolean idFlag = false;
    boolean setFlag = false;

    MyParseHandler (){
	super();
	//	metadataList = new MetadataList();
    }
    
    public void startElement(String uri, String localName, String rawName, Attributes atts)
           throws SAXException{
	if (localName.equals("record")){
            record = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>";
            recordFlag = true;
            md = new Metadata();
            md.setFormat(format);
            md.setArchive(dp.m_id);
	}
	//  if (localName.equals("resumptionToken"))
        //    tokenFlag = true;

        if (recordFlag){
	    record += "<"+ localName + ">";

	    if(localName.equals("identifier"))
	         idFlag = true;
	    if(localName.equals("setSpec"))
		  setFlag = true;

        }

    }

    public void endElement (String uri, String localName,String rawName) throws SAXException {
        if (recordFlag){
          record += "</"+ localName + ">";
	}
	if (localName.equals("record")){
	    //  System.out.println(record);
            md.setMetadata(record);
	    recordFlag = false;
           
            md.setIdentifier(identifier);
            identifier = "";
            md.setSets (setList);
            setList = "";
	    // metadataList.add(md);
	   
	}
        if(localName.equals("identifier"))
	    idFlag = false;
        if(localName.equals("setSpec"))
	    setFlag = false;

	//if (localName.equals("resumptionToken"))
	//  tokenFlag = false;
    }

    public void characters (char[] ch, int start, int end) throws SAXException {
	String s = new String (ch, start, end);
        if (recordFlag){
	    record += s;
	}
        if (idFlag)
	    identifier = s;
        if (setFlag){
            String setname = dp.m_partitionList.getSpecByName(s);
            if (setList.length() == 0)
                setList += setname;
             else
	        setList += " | " + setname;
	} 
	// if (tokenFlag)
	//    resumptionToken = s;

    }
   
 }
    */

}






