package oairequester;
import java.util.*;
import java.io.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import javax.xml.parsers.*;
import org.xml.sax.helpers.*;


public class ListRecords extends Response{
    String partition;
    public String resumptionToken=null;
    String url4filter=null;
    String format=null;

    Vector deletedList = new Vector(); //to contain the identifiers of deleted records

    public ListRecords(DataProvider dp){
        super(dp);
    }


    public void  read(String set,String file_after,String file_before,String meta_format)throws java.io.IOException{
	String s;
	partition=set;
	if (partition==null)
	    s="";
	else
	    s="set="+URIEncoder.encode(partition);

	if (file_after!=null){
	    if (s!="")
		s=s+"&from="+file_after;
	    else
		s="from="+file_after;
	}
	
	if (file_before!=null){
	    if (s!="")
		s=s+"&until="+file_before;
	    else
		s="until"+file_before;
	}
	
	
	if(meta_format!=null){
            format= meta_format;
	    if (s!="")
		s=s+"&metadataPrefix="+meta_format;
	    else
		s="metadataPrefix="+meta_format;
	}
	read(dp.m_url+"?verb=ListRecords&"+s);
	url4filter=dp.m_url+"?verb=ListRecords&"+s;

    }

  
    public Result parse () throws oairequester.ParseException,java.io.IOException{

        if (resumptionToken!=null){
             read(dp.m_url+"?verb=ListRecords&resumptionToken="+URIEncoder.encode(resumptionToken));
	       
         }
         resumptionToken=null;
         
         if (deletedList.size()>0)
	     deletedList.removeAllElements();

	 ListRecordsHandler handler=new ListRecordsHandler(format,dp.m_id,partition,input);
	 MetadataList metadataList=handler.getMetadataList();
	 resumptionToken=handler.getResumptionToken();
	 deletedList=handler.getDeletedList();
	 
	 if  (resumptionToken != null && resumptionToken.trim().equals(""))
	     resumptionToken=null;
	 
	 return metadataList;	         	       
    }


    
   
    public String getResumptionToken(){
        return resumptionToken;
    }

     public Vector getDel() { 
	return deletedList;
    }
}


  










