package oairequester;
import java.util.*;
public class Partition{
    String m_name;
    String m_description;
    PartitionList subPartition;
    public Partition(String name,String description){
    	m_name=name;
	    m_description=description;
    }

    public PartitionList getSubList(){
        if (subPartition==null){
            subPartition=new PartitionList();
        }
        return subPartition;
    }

    Vector getHierarchyPartition(String prefix,int level){
        Vector list=new Vector();
        if ((level==0)||(subPartition==null)){
            if (prefix==null)
                list.add(m_name);
            else
                list.add(prefix+":"+m_name);
        }
        else{
            if (prefix==null)
                list.addAll(subPartition.getHierarchyPartition(m_name,level--));
            else
                list.addAll(subPartition.getHierarchyPartition(prefix+":"+m_name,level--));
        }
        return list;
    }


     Vector getHierarchyPartitionWithParent(String prefix,int level){
        Vector list=new Vector();
        if (prefix==null)
                list.add(m_name);
            else
                list.add(prefix+":"+m_name);
        if ((level!=0)&&(subPartition!=null)){
            if (prefix==null)
                list.addAll(subPartition.getHierarchyPartition(m_name,level--));
            else
                list.addAll(subPartition.getHierarchyPartition(prefix+":"+m_name,level--));
        }
        return list;
    }

     Vector getHierarchyPartitionNameWithParent(int level){
        Vector list=new Vector();
        String space="";
        for (int k=0;k<8*(1-level);k++){
            space+=" ";
        }
        list.add(space+m_description);

        if ((level!=0)&&(subPartition!=null)){
               list.addAll(subPartition.getHierarchyPartitionName(--level));
             }
        return list;
    }

}
