package oairequester;
import java.io.File;
import java.io.*;
import java.net.*;
import org.w3c.dom.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.*;
import java.util.*;


public abstract class Response {
    static String TEMP_FILE_PATH = "tmp/response.xml";  
    DataProvider dp;
    InputSource input;
    String requesturl=null;

    public Response(DataProvider dp){
        this.dp=dp;
    }


    public void read(File f) throws java.io.FileNotFoundException{
        input=new InputSource(new FileReader(f));
    }

    public void read(String url) throws java.io.IOException{
	//To avoid rapid Fire request 
	try{ 
	    Thread.sleep(Config.SLEEP_BETWEEN_REQUEST*1000); 
	} 
	catch (Exception sleepe){ 
	    System.out.println(sleepe); 
	}
 
        requesturl=url;
        URL u=new URL(requesturl);
        Date today=new Date();
        System.out.println(requesturl+" "+today);
        HttpURLConnection conn=null;
	//will try at least three times whatever is wrong.
	int count=0;
        for(;;){
            try{
		count++;
                conn=(HttpURLConnection)u.openConnection();
                conn.setRequestProperty("User-Agent",Config.AGENT);
                input=new InputSource(conn.getInputStream());
                System.out.println("responsecode:"+ conn.getResponseCode ());
                break;
            }
            catch(IOException e){
		System.out.println(e);
                System.out.println("responsecode:"+ conn.getResponseCode ());
                if ((conn.getResponseCode ()==503)&&(conn.getHeaderField ("Retry-After")!=null)){
                    int sleeptime=Integer.parseInt (conn.getHeaderField ("Retry-After"));
                    try{
                        System.out.println("503 error retry: sleep "+sleeptime+" seconds");
                        Thread.sleep (sleeptime*1000);
                    }
                    catch(Exception ex){
                    }
                }
		else if (count<3){
		    continue;
		}
		else
                   throw e;
            }
	  
	 
        }
    }

    /**Save XML into file system to prevent large chunks of XML running out of memory */
    public void read2file(String url) throws java.io.IOException{
	//To avoid rapid Fire request 

	try{ 
	    Thread.sleep(Config.SLEEP_BETWEEN_REQUEST*1000); 
	}
	catch (Exception sleepe){ 
	    System.out.println(sleepe); 
	}
 
        requesturl=url;
        URL u=new URL(requesturl);
        Date today=new Date();
        System.out.println(requesturl+" "+today);
        HttpURLConnection conn=null;

	    
	//will try at least three times whatever is wrong.
	int count=0;
        for(;;){
            try{
		count++;
                conn=(HttpURLConnection)u.openConnection();
                conn.setRequestProperty("User-Agent",Config.AGENT);
                //input=new InputSource(conn.getInputStream());
	        loadinFile(conn.getInputStream());

                System.out.println("responsecode:"+ conn.getResponseCode ());
                break;
            }
            catch(IOException e){
		System.out.println(e);
                System.out.println("responsecode:"+ conn.getResponseCode ());
                if ((conn.getResponseCode ()==503)&&(conn.getHeaderField ("Retry-After")!=null)){
                    int sleeptime=Integer.parseInt (conn.getHeaderField ("Retry-After"));
                    try{
                        System.out.println("503 error retry: sleep "+sleeptime+" seconds");
                        Thread.sleep (sleeptime*1000);
                    }
                    catch(Exception ex){
                    }
                }
		else if (count<3){
		    continue;
		}
		else
                   throw e;
            }
	  
	 
        }
    }

    private void loadinFile (InputStream in){
	byte [] buff = new byte [1000];
	//int off=0, len=999;
	int len;
	try{
	    //OutputStream os = new FileOutputStream (TEMP_FILE_PATH);
            DataOutputStream os = new DataOutputStream ( new BufferedOutputStream ( new FileOutputStream(TEMP_FILE_PATH)));
	    
	    //BufferedReader inbr = new BufferedReader ( new InputStreamReader ( in));
	      DataInputStream inds = new DataInputStream (new BufferedInputStream (in));							
	    while ( (len=inds.read(buff, 0, 1000))  != -1 ){
		os.write(buff, 0, len);
	    }
	    os.close();
	    System.out.println("The XML is loaded into file");
	}catch (Exception ex){
	    System.out.println("Error occurs in writing temp file");
	}
	
    }

    public void print(){
    }
    
    //public Result preParse() throws ResponseException;

    public abstract Result parse() throws oairequester.ParseException,java.io.IOException,ResponseException;

    
    Element  validate() throws IOException,oairequester.ParseException{
	try {

	    DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.
	    							newInstance();
	    DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
            docBuilder.setEntityResolver(null);
	    Document doc = docBuilder.parse (input);
	    // normalize text representation
	    doc.getDocumentElement ().normalize ();
            Element e = doc.getDocumentElement();
            
            String rootName = e.getTagName(); 
            if (rootName.equalsIgnoreCase("OAI-PMH")){ //For OAI V2.0
		NodeList nl = e.getChildNodes();
                for (int i=0; i<nl.getLength(); i++){
		    Node child = nl.item(i);
		    if(child.getNodeType() == Node.ELEMENT_NODE){
			String ename = ((Element)child).getTagName();

                        if (ename.indexOf("response")<0 && ename.indexOf("request")<0)
			    return (Element)child;
                    }
		}
                return null;
	    }
            else   // For OAI V1.1/1.0       
              return e;

	} catch (SAXParseException err) {
	    err.printStackTrace();
        throw new ParseException("** Parsing error"
		+ ", line " + err.getLineNumber ()
		+ ", uri " + err.getSystemId ());
	    // print stack trace as below

	} catch (SAXException e) {
	    e.printStackTrace();
	    throw new ParseException(e.getMessage());

	}
	catch (Throwable t) {
	    t.printStackTrace();
	    throw new ParseException(t.getMessage());
	}
 }

    public  void write(File f) throws IOException{

        URLConnection conn=(new URL(requesturl)).openConnection();
        conn.setRequestProperty("User-Agent","liu_x@cs.odu.edu");
        conn.connect();
        InputStream in =conn.getInputStream();
        BufferedReader dataIn=new BufferedReader(new InputStreamReader(in));

        FileWriter writer=new FileWriter(f);
        String line;
        while((line=dataIn.readLine())!=null){
                writer.write(line+"\n");
        }
        dataIn.close();
        writer.flush();
        writer.close();
    }

    String getString(){
      String xmldoc = "";
      try{
       BufferedReader breader = new BufferedReader (
                      new InputStreamReader(input.getByteStream()) );
       String line;
      
       while( (line=breader.readLine()) != null ){
         xmldoc += line;
       }

      }catch (IOException ioe){
          System.out.println(ioe);
      }
      return xmldoc;
    }
}









