package parser;

import javax.xml.parsers.*;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.*;
import java.sql.*;
import java.io.*;

import java.util.*;
import oairequester.*;
import db.*;
//import scheduler.*;

public class DB2DB {
    ConnectionPool m_connectionPool=null;
    Connection connection=null;
    PreparedStatement mainstmt=null, setstmt=null, archivestmt=null;

    String type="-n"; // '-a' is allover parsing and '-n' is only-new parsing    
   
   public DB2DB(String type){
      m_connectionPool=new ConnectionPool(); 
      try{ 
            m_connectionPool.initialize();
      }
      catch(Exception ex){
            ex.printStackTrace();
      }
      this.type = type;
   }
   public DB2DB(ConnectionPool pool, String type){
  
       m_connectionPool = pool;
       this.type = type;
   }

   public void initstmt(String format){
       String selectArchive = "select distinct archive from main where format='" + format +"'";
      
       String selectStr = "select id, archive, sets, metadata from main";
       selectStr += " where format='"+ format + "'" + " and archive=?";

	if (type.trim().equals("-n")) {
           selectArchive += " and (parsed is null or parsed='N' )";
	   selectStr += " and (parsed is null or parsed='N' )";
	}

        String setFlagStr = "update main set parsed=? where id=? and format='" + format +"'";

        try{
           connection=m_connectionPool.getConnection();

           archivestmt = connection.prepareStatement(selectArchive);
           mainstmt = connection.prepareStatement(selectStr);
           setstmt =  connection.prepareStatement(setFlagStr);
        }catch(Exception e){
            System.out.println(e);
        }
	//System.out.println("Parse is ready ...");
   }

   public void closeConnection(){
       try{
	   mainstmt.close(); 
       }
       catch(Exception e){
	   System.out.println(e);
       }

       if (connection!=null)
            m_connectionPool.close(connection);
	
        connection=null;
   }


   public void parse(String metafm){
       
       initstmt(metafm);
       
       String destin = null;
       MetaParser mp = null;

       if (metafm.endsWith("dc")){
	   mp = new DCMetaParser();
           destin = "dc";
       }
       
       Record2DB rcd2db = null;

        if (m_connectionPool.getDBType()==ConnectionPool.MYSQL)
            rcd2db = new Record2Mysql(m_connectionPool,destin);
        if (m_connectionPool.getDBType()==ConnectionPool.ORACLE)
            rcd2db = new Record2Oracle(m_connectionPool,destin); 
       
	if (type.equals("-n"))
             System.out.println("Start Parsing (only new records)");
        else
             System.out.println("Start Parsing (all records)");

        Vector a_vector = new Vector();
	try{ 
	    ResultSet a_rs = archivestmt.executeQuery();
        
            while (a_rs.next()){
		String archive = a_rs.getString(1);
                a_vector.add(archive);
	    }
	}catch(Exception e){
           System.out.println("\nException in getting archives:" +e.getMessage());
       }     
       
	Iterator itr = a_vector.iterator();
        while (itr.hasNext()){
	  String archivename = (String)itr.next();
          int count = 0;
          System.out.println("Parsing Archive: " + archivename + " ..");
 
          try{
	     mainstmt.setString(1, archivename);
             ResultSet rs = mainstmt.executeQuery();
        
	     while (rs.next()) {
	       String id = rs.getString(1);
               String archive = rs.getString(2);
               String sets = rs.getString(3);
	       // InputStream rcd = rs.getBinaryStream(5);
	       String strxml = rs.getString(4);
            
               InputSource rcd = new InputSource (new StringReader(strxml));

	       // System.out.println("Start parsing: " + "\n " + strxml);

               Result record=null;
	       try{		      
                 mp.validate(rcd, archive, sets);
           
                 record = mp.parseOAMS();
	       }catch(Exception e){
		   //Set the Flag bit 'parsed' in MAIN
		   setstmt.setString(1,"E");
		   setstmt.setString(2, id);
		   setstmt.executeUpdate();
		   
		   System.out.println("\n***Record " + id + " has parsing error...");
	//	   System.out.println(strxml);
		   continue;
	       }

	       System.out.print("*");


              if (record==null){
                System.out.println("\n***Record " + id + " has not got parsed value ..");
                System.out.println(strxml);
		continue;
              }
            
              try{
                rcd2db.add((oairequester.Record)record);
              }catch(Exception e){
               System.out.println("\n***Record " + id + "  is Not added into " + destin + " ..");
	       continue;
	      }
             
            
              try{ //Set the Flag bit 'parsed' in MAIN
		  setstmt.setString(1,"Y");
		  setstmt.setString(2, id);
		  setstmt.executeUpdate();
	      } catch(Exception e){
		  System.out.println("\n***Failed in setting PARSED bit in MAIN");
		  continue;
	      }  
              count++;
           }
          rs.close();     

          }catch (Exception e){
	   System.out.println("\nException in parse:" +e.getMessage());
          }
       	   
          System.out.println("\n" + count +" records are parsed and added to " + destin);
          System.out.println("Finish parsing " + archivename);
	}
       closeConnection();
   }

    /*private void add2DB(oairequester.Record record, String table){
	
        rcd2db.add(record);
	}*/
 
}








