package scheduler;
import java.util.*;
import oairequester.*;
import java.io.*;

/**
 * Give a harvested "list-contents" file name, this task can add records to database 
 * However, this task has a limitation that partition is missed in record generally, 
 * To make data complete in database, This task can be companied by HarvestUpdatePartition 
 * task. 
 */

public abstract class HarvestFromFile implements Task{
    DataProvider dp;
    Record2DB oo;
    File file;
    boolean done=false; 
    /**
     *@return false
     */
    public boolean forever(){ 
	return false;
    }
/**
 * Constructor
 * @param dp the data provider
 * @param oo
 * @param file
 */


    public  HarvestFromFile(DataProvider dp,Record2DB oo,File file){ 
	this.dp=dp;
        this.oo=oo;
        this.file=file; 
    }
    /**
     * prepare
     */
    public void prepare() throws oairequester.ParseException,java.io.IOException{         done=false;
    }// read partition 
    /**
     *
     */
    public void run() throws ParseException,java.io.IOException{
        if (file.isFile()){ 
	    dp.listRecords.read(file); 
	    MetadataList m_mlist =(MetadataList)(dp.listRecords.parse()); 
		      
		oo.add(m_mlist);
	}
        else{  
	    File filelist[]=file.listFiles();   
	    for (int i=0;i<filelist.length;i++){ 
	       
		dp.listRecords.read(filelist[i]); 
		MetadataList m_mlist =(MetadataList)(dp.listRecords.parse()); 
		      
		oo.add(m_mlist);
            }
        }
        done=true;
    }
    /**
     * @return if done (true) or not (false)
     */
    public boolean isDone(){    
	return done; 
    }
}
