package scheduler;


import java.util.*;
import oairequester.*;
import log.*;
/**
 * 
 */
public class HarvestListAddAll extends HarvestByPartition{
/**
 * Constructor
 * @param dp the data provider
 * @param oo
 * @param m_log
 */
    public HarvestListAddAll(DataProvider dp,Record2DB oo, Log m_log){
        super(dp,oo, m_log);
    }

    /** @return false */
    public boolean forever(){
        return false;
    }
/**
 * 
 */
    public void run() throws ParseException,java.io.IOException{
	if (enum.hasMoreElements()) {
               String partitionname=(String)(enum.nextElement());
	       if (partitionname.equals (FAKEFLAG))
                    partitionname=null;
               else
		   System.out.println("Harvesting set: "+ partitionname);


   	       Enumeration metafm = mfList.elements();
               while (metafm.hasMoreElements()){  
                   m_logrecord = new LogRecord(Calendar.getInstance().getTime(),"HarvestListAddAll",dp.getId(),"MAIN", true);
	           m_log.writeBeginLog(m_logrecord);
 	   
		   String metaFormat = (String)metafm.nextElement();
                   System.out.println("Start harvesting "+metaFormat + " .....");

		   // long  s_read = System.currentTimeMillis();    
		   
		   dp.listRecords.read(partitionname,null,null,metaFormat);
		   // long e_read =  System.currentTimeMillis();
		   // System.out.println("Read takes: " + (e_read-s_read));

		   int totalsize = 0;
		  
		   do{    
		       // long  s_parse = System.currentTimeMillis();  
		       
                       MetadataList m_mlist =null;
		       
		       m_mlist= (MetadataList)( dp.listRecords.parse()); 
		      
		       oo.updateResumptionToken(dp.m_id,dp.listRecords.getResumptionToken());
			
		    

		       // long e_parse =  System.currentTimeMillis();
		       // System.out.println("Parse takes: " + (e_parse-s_parse));

                       totalsize = totalsize+(m_mlist==null?0:m_mlist.size());

		       // long  s_add = System.currentTimeMillis();  
                       oo.add(m_mlist); //Store matadata into database
		       // long e_add =  System.currentTimeMillis();
		       // System.out.println("Add to DB takes: " + (e_add-s_add));
		       Vector dl = dp.listRecords.getDel();
		       oo.delete (dl, dp.m_id);// delete the record from dc,free and main table. and save the deleted information into deleterecord table.
  
		       try{
			   Thread.sleep(Config.SLEEP_BETWEEN_REQUEST);
		       }
		       catch(Exception e){
			   System.out.println(e);
		       }
		    } while(dp.listRecords.getResumptionToken()!=null);
		 
		   oo.updateResumptionToken(dp.m_id,"");
		   m_logrecord.m_status = "OK";
		   m_logrecord.m_detail = dp.getUrl() + "?verb=ListRecords";
		   m_logrecord.m_totalnum = totalsize;
		   m_log.writeEndLog(m_logrecord,dp.getId());

                   System.out.println("End of "+metaFormat + "harvest");
                }
       }
	else {
	   done=true;
           oo.updateHarvestmethod(dp.m_id);
	}
    }
    /**
     * convert to string
     * @return string
     */
    public String toString(){
        return (dp.m_id + " HarvestListAddAll "+ Clock.startDate ());
    }
}







