package scheduler;


import java.util.*;
import oairequester.*;
import log.*;
/**
 * 
 */

public class HarvestListAddNew extends HarvestByPartition{
/**
 * Constructor
 * @param dp the data provider
 * @param oo
 * @param m_log
 */
    public HarvestListAddNew(DataProvider dp,Record2DB oo, Log m_log){
        super(dp,oo,m_log);
    }
// read partition
    /** @return false */
    public boolean forever(){
        return true;
    }
    /**
     * 
     */
    public void run() throws ParseException,java.io.IOException{
        if (enum.hasMoreElements()) {
	    String partitionname=(String)(enum.nextElement());
	    if (partitionname.equals (FAKEFLAG))
		partitionname=null;
	    else
		System.out.println("Harvesting set: "+ partitionname);

	    try{
		Date lastharvesttime = dp.getLasttime();

		Enumeration metafm = mfList.elements();
		
		while (metafm.hasMoreElements()){

		    m_logrecord = new LogRecord(Calendar.getInstance().getTime(),"HarvestListAddNew",dp.getId(),"MAIN", true);
		    m_log.writeBeginLog(m_logrecord);
   	   
		    String metaFormat = (String)metafm.nextElement();
		    System.out.println("Start harvesting "+metaFormat + " ....");    

		    if (lastharvesttime == null)
			dp.listRecords.read(partitionname,Clock.startDate(),null,metaFormat);
		    else 
			dp.listRecords.read(partitionname,Clock.startDate(lastharvesttime, granularity),null,metaFormat);

		    int totalsize = 0;

		       do{                     
			   MetadataList m_mlist = (MetadataList)( dp.listRecords.parse()); 
			   totalsize = totalsize+(m_mlist==null?0:m_mlist.size());
			   oo.add(m_mlist); //Store matadata into database
			   Vector dl = dp.listRecords.getDel();
			   oo.delete (dl, dp.m_id);// delete the record from dc,free and main table. and save the deleted information into deleterecord table.
  

			  

		         } while(dp.listRecords.getResumptionToken()!=null);
		       
		       m_logrecord.m_status = "OK";
		       m_logrecord.m_detail = dp.getUrl() + "?verb=ListRecords";
		       m_logrecord.m_totalnum = totalsize;
		       m_log.writeEndLog(m_logrecord,dp.getId());
                       
                       System.out.println("End of "+metaFormat + " metadatas");  
		    } 
		       
		   } catch(Exception e){
		       System.out.println(e);
		       LogRecord mm = new LogRecord(Calendar.getInstance().getTime(),"HarvestListAddNew", dp.getId() , "MAIN",false);
		       mm.m_status = "Error";
		       mm.m_detail = e.toString();
		       m_log.writeErrorLog(mm); 
		   }
	    
          }
          else
                done=true;

    }
    /**
     * convert to string
     * @return string
     */
 
    public String toString(){
        return (dp.m_id + " HarvestListAddNew "+ Clock.startDate ());
    }
}




