package scheduler;


import java.sql.*;
import java.io.*;

import java.net.*;
import java.util.*;
import oairequester.*;
import java.text.*;
import db.*;
/**
 * insert record into db
 */
public abstract  class Record2DB{
    ConnectionPool m_connectionPool=null;
    Connection connection=null;
    PreparedStatement dcstmt=null, mainstmt=null, dpliststmt=null;
    Statement deletestmt=null;
    int idexist=0;
   
    DateNormalizer dn=new DateNormalizer();
    
    /** @param pool the connection pool */
    public Record2DB(ConnectionPool pool){
        m_connectionPool=pool;

    }
    /**
     * init sql statement
     */
    public void initstmt(){
        try{
        connection=m_connectionPool.getConnection();
        mainstmt = connection.prepareStatement("insert into main (id, format, archive, sets, metadata, timestamp) values (?, ?, ?, ?, ?, ?)");
	deletestmt=connection.createStatement(); 

        }catch(Exception e){
            System.out.println(e);
        }

   }
    /** close connection*/
   public void closeConnection(){

       try{
	   mainstmt.close();
	   deletestmt.close();
       }
       catch(Exception e){
	   System.out.println(e);
       }

       if (connection!=null)
            m_connectionPool.close(connection);
	
        connection=null;
   }

    /** 
     * Added by Yang Zhao, Mar 2002 
     * @param metadata oairequester.Metadata
     * @return num of updated records.
     */
    private int mainUpdate(oairequester.Metadata metadata) throws SQLException{
       
       mainstmt.setString(1,clean(metadata.m_identifier));
       mainstmt.setString(2,clean(metadata.m_format));
      
       mainstmt.setString(3,clean(metadata.m_archive));
       mainstmt.setString(4,clean(metadata.m_sets));
        mainstmt.setString(6,clean(metadata.m_timestamp));
       try {
	   //setString() doesn't work when the string is long. setCharacterStream() is used instead. 
	   
	   StringReader sr = new StringReader(clean(metadata.m_metadata));
           int len = metadata.m_metadata.length();
         mainstmt.setCharacterStream (5, sr, len );
       
	   // mainstmt.setString(5,clean(metadata.m_metadata)); 
       }catch (SQLException sqle){
           System.out.println("Set String to Long !!!!" + sqle.getMessage());
       } 
       int i = mainstmt.executeUpdate();
       return i;
    
    }

   

    private String clean(String s){
        if (s==null)
            return "";

       	StringBuffer buffer=new StringBuffer();
   	    for (int i=0;i<s.length();i++){
                if (s.charAt(i)=='\'')
                    buffer.append(" ");
                else
                    buffer.append(s.charAt(i));
	        }
    	return buffer.toString().trim();
    }
    /** abstract reindex */
    public abstract void reindex();


   /** 
    * @param mList
    * Added by Yang Zhao Mar 2002 
    */
    public void add(oairequester.MetadataList mList){
	   System.out.println("Size "+ mList.size());
	   if (mList.size()==0)
	       return;
	   initstmt();

           System.out.println("Size "+ mList.size());
           for (int i=0;i<mList.size();i++)
                add((Metadata)mList.get(i));
	    
            closeConnection();

    }    
   /** 
    * @param m
    * Added by Yang Zhao Mar 2002 
    */
     public void add(oairequester.Metadata m){
	if (m==null)
	    return;
        boolean useflag=false;
        if (connection==null){
            initstmt();
            useflag=true;
        }

	try{
            delete(m);
            mainUpdate(m);
   
        }
        catch(SQLException e)
        {
            System.out.println(e.getErrorCode()+e.toString());
            String errmsg=m.m_identifier+ "--"+ e.getErrorCode()+e.toString();
	    log.FileLog.writeError(errmsg);     
        }
        if (useflag)
            closeConnection();

    }

  
     private void delete(oairequester.Metadata md){
        Statement s=null;
        try{
            s=connection.createStatement();	   
	    
	    s.executeUpdate("delete from main where id='"+clean(md.m_identifier.trim())+"'");
	
	}
	catch (SQLException e){
	    System.out.println(e);
	}
	finally{
	    try{
		s.close();
	    }
	    catch(Exception e){
		System.out.println(e);
	    }
	}
     }
    
	
    public void updateResumptionToken(String id,String resumptionToken){
	
    try{
            Connection conn = m_connectionPool.getConnection();            
            Statement s=conn.createStatement();
             
            s.executeUpdate("update dplist set resumptionToken='"+resumptionToken+"' where identifier='" + id+"'");
            s.close();
            m_connectionPool.close(conn);
        }
        catch (SQLException e){
            System.out.println("Update resumptionToken: " + e);
        }
    }

    /**
     * update identify info
     * @param info
     */
     public void updateIdentify(IdentifyInfo info){
        boolean useflag=false;
        Statement querys=null,updates=null;
        PreparedStatement ps=null;

        try{
           connection=m_connectionPool.getConnection();
           querys=connection.createStatement();
           ResultSet rs=querys.executeQuery("select id from dpinfo where id='"+clean(info.id)+"'");
           if (!rs.next()){
               String query="insert into dpinfo(id,BASEURL,"+
               "homepage,NAME,VERSION,ADMINEMAIL,DELIMITER,SAMPLEIDENTIFIER,SCHEMA,datestamp) values (?,?,?,?,?,?,?,?,?,?)";
               ps = connection.prepareStatement(query);
               ps.setString(1,clean(info.id));
               ps.setString(2,clean(info.baseURL ));
               ps.setString(3,clean(info.homepage));
               ps.setString(4,clean(info.name));
               ps.setString(5,clean(info.version ));
               ps.setString(6,clean(info.adminemail));
               ps.setString(7,clean(info.delimiter ));
               ps.setString(8,clean(info.sampleIdentifier ));
               ps.setString(9,clean(info.schema));
            
               SimpleDateFormat formatter
                   = new SimpleDateFormat ("yyyy-MM-dd");
                 java.util.Date currentTime_1 = new java.util.Date();
              String dateString = formatter.format(currentTime_1);

               ps.setString(10,dateString);
               ps.executeUpdate();
           }
           //existing data provider
           else{

	       String query="update dpinfo set version=?,name=?,baseURL=? where id=?";
               ps = connection.prepareStatement(query);
               ps.setString(1,clean(info.version));
	       ps.setString(2,clean(info.name));
               ps.setString(3,clean(info.baseURL ));
	       ps.setString(4,clean(info.id));
               ps.executeUpdate();
	   

           }

        }
        catch (SQLException e){
            System.out.println(e.getErrorCode()+e.toString ());

        }
        finally{
            try{
                if(querys!=null)
                    querys.close ();
                if (updates!=null)
                    updates.close();
                if (ps!=null)
                    ps.close();
                m_connectionPool.close(connection);
                connection=null;
            }
            catch(Exception e){
                System.out.println(e);
            }

        }


    }

   

    public void updateHarvestmethod(String identifier){        
	try{
            Connection conn = m_connectionPool.getConnection();            
            Statement s=conn.createStatement();
             
            s.executeUpdate("update dplist set harvestmethod='fresh_mass' where identifier='" + identifier+"'");
            s.close();
            m_connectionPool.close(conn);
        }
        catch (SQLException e){
            System.out.println("Update Harvest Method: " + e);
        }
    }


     public void delete(Vector idList, String av){
	 int existInDc=0;
	 int existInFree=0;
	 int existInMain=0;
	 boolean useflag=false;
	 if (connection==null){
	     initstmt();
	     useflag=true;
	 }				
	 if (idList !=null && idList.size()>0) {
	     Iterator itr = idList.iterator();
	     
	     Statement s=null;
	     try{
		 s=connection.createStatement(); 
		 
		 while (itr.hasNext()){
		     String id = (String)itr.next();
		     System.out.println("Try to Delete " + id); 
		     try{
			 existInDc=s.executeUpdate("delete from dc where id='"+clean(id.trim())+"'");
		     }
		     catch(Exception ex){
		     }
		     
		     try{
			 existInFree=s.executeUpdate("delete from free where id='"+clean(id.trim())+"'");
		     }
		     catch(Exception ex){
		     }
		     
		     try{
			 existInMain=s.executeUpdate("delete from main where id='"+clean(id.trim())+"'");
		     }
		     catch(Exception ex){
		     }               
		     
		     if(existInDc!=0 ||existInFree!=0||existInMain!=0)					writeDeleteRecord(clean(id.trim()), av);
		 }
		 
	     }
	     catch (SQLException e){
		 System.out.println(e);
	     }
	     finally{
		 try{
		     s.close();
		 }
		 catch(Exception e){
		     System.out.println(e);
		 }
	     }     
	     
	 }
	 if (useflag)
	     closeConnection();     
     } 
    
    
    public void writeDeleteRecord(String id, String av){       
	java.sql.ResultSet rset=null; 	    
	try{				
	    String d_id = id;
	    String archive=av;
	    SimpleDateFormat formatter= new SimpleDateFormat ("yyyy-MM-dd");
	    java.util.Date currentTime_1 = new java.util.Date();
	    String datestamp = formatter.format(currentTime_1);					
	    rset=deletestmt.executeQuery("select id from deleterecord where id='"+d_id+"'");			
	    if(!rset.next())
		deletestmt.executeUpdate("insert into deleterecord (id,archive,datestamp,requester) values ('"+d_id+"','"+archive+"','"+datestamp+"','"+archive+"')"); 			
	}	
	catch (SQLException e){
	    System.out.println(e);
	}  		    }
    
    
    
  
    
}








