package scheduler;
import java.io.*;
import java.sql.*;

import db.*;

/**
 * Save data to Oracle database
 * @author xiaoming liu
 */

public class Record2Oracle extends Record2DB{
   /** @param pool the connection pool */
    public Record2Oracle(ConnectionPool pool) {
        super(pool);
    }

    /**
      * User could get rapid result by doing reindex*
      */

     public void reindex(){
	connection=m_connectionPool.getConnection();
        Statement s=null;
	String indexes[]={"arc_dc_description","arc_dc_title","arc_dc_creator","arc_dc_sets","arc_dc_subject","arc_dc_publisher","arc_dc_discovery","arc_dc_type","arc_dc_format","arc_dc_source","arc_dc_language","arc_dc_language","arc_dc_relation","arc_dc_coverage","arc_dc_rights","arc_dc_datestamp","arc_free_alltext","arc_dcnew_subject"};
	
        try{
            s=connection.createStatement();
	    for(int i=0;i<indexes.length;i++){
		try{
 s.execute("alter index " + indexes[i]+ " rebuild online parameters('sync')");
		}
		catch(Exception ex){
		    System.out.println(ex);
		    System.out.println(indexes[i] + " cannot be indexed");
		}
	    }

        }
        catch (SQLException e){
            System.out.println(e);
        }
        finally{
            try{
                s.close();
		m_connectionPool.close(connection);
            }
            catch(Exception e){
                System.out.println(e);
            }
        }
    }


} 
