package scheduler;

import java.io.*;
import java.lang.reflect.*;
import java.util.*;
import java.text.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;
import javax.xml.transform.dom.*;
/** XML updater */
public class XMLUpdater
{
    /** create document root */
    public static Document createDocumentRoot()
    {
	try
	    {
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance ();
		dbf.setNamespaceAware (true);
		DocumentBuilder db = dbf.newDocumentBuilder ();
		Document doc1 = db.newDocument ();
		return doc1;
	    }catch(Exception e)
		{
		    System.out.println(e);
		    return null;
		}
    }
    /** 
     * convert from DOM to stream
     * @param doc1 the docm document
     * @param writer the output stream
     */
    public static void Dom2Stream(org.w3c.dom.Document doc1, java.io.Writer writer)
    	{
	    if (writer==null)
      	     	System.out.println("writer is null");
       	try
		{
           		TransformerFactory tFactory = TransformerFactory.newInstance();
           		Transformer transformer = tFactory.newTransformer();
           		transformer.transform(new DOMSource(doc1), new StreamResult(writer));
      	}
      	catch (Exception e)
		{
           		try
			{
           			e.printStackTrace();
           		}
           		catch (Exception ex){System.out.println(e);}
		}
	}
    /** 
     * updater
     * @param harvesttime harvest time
     */
    
    public void updater(String harvesttime)
    {
	//		System.out.println(a);
	String xmlurl = "./conf/dps.xml";
	Document doc=null;
	int yesflag=0;
	try
	    {
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder = factory.newDocumentBuilder();
		ClassLoader cl =  getClass().getClassLoader();
		java.io.InputStream in;
		if(cl != null)
		    {
			in = cl.getResourceAsStream(xmlurl);
		    }
			else
			{
				in = ClassLoader.getSystemResourceAsStream(xmlurl);
			}
			if(in==null)
			{
				throw new Exception("Data Provider configuration file '"+xmlurl+"'not found");
			}
			doc = builder.parse(in);
		}catch(Exception err)
		{
			System.err.println("An error occured: " + err);
		}
    		Document doc1=createDocumentRoot(); 
//		File xmlwrite = new File("./conf/dps.xml");
		Element dp1=doc1.createElement("DATA-PROVIDER");
		if(doc != null)
		{
			String root=doc.getDocumentElement().getTagName();
			if(root!=null)
			{
				for(Node node = doc.getDocumentElement().getFirstChild();node != null; node = node.getNextSibling())
				{
					if (node.getNodeName().equals("DP")) 
					{
						Element dp2=doc1.createElement("DP");
						yesflag = 0;
						for (Node dp = node.getFirstChild();dp != null; dp = dp.getNextSibling()) 
						{
							Element id=doc1.createElement("ID");
							Element harvesturl=doc1.createElement("HARVESTURL");
							Element website=doc1.createElement("WEBSITE");
							Element shortname=doc1.createElement("SHORTNAME");
							Element sets=doc1.createElement("SETS");
							Element active=doc1.createElement("ACTIVE");
							Element harvestmethod=doc1.createElement("HARVESTMETHOD");
							Element lastharvesttime=doc1.createElement("LASTHARVESTTIME");

			    				if (dp.getNodeName().equals("ID")) 
							{
		                  			if (dp.getFirstChild()!=null)
								{
					    				id.appendChild(doc1.createTextNode(dp.getFirstChild().getNodeValue()));
									dp2.appendChild(id);
								}
			    				}
		    					if (dp.getNodeName().equals("HARVESTURL")) 
							{
                 						if (dp.getFirstChild()!=null)
								{
					    				harvesturl.appendChild(doc1.createTextNode(dp.getFirstChild().getNodeValue()));
									dp2.appendChild(harvesturl);
								}
				    			}
				    			if (dp.getNodeName().equals("SETS")) 
							{
            	            			if (dp.getFirstChild()!=null)
								{
					    				sets.appendChild(doc1.createTextNode(dp.getFirstChild().getNodeValue()));
									dp2.appendChild(sets);
								}
		    					}
	    						if (dp.getNodeName().equals("ACTIVE")) 
							{
                 						if (dp.getFirstChild()!=null)
								{
									if(dp.getFirstChild().getNodeValue().equals("yes"))
										yesflag=1;
					    				active.appendChild(doc1.createTextNode(dp.getFirstChild().getNodeValue()));
									dp2.appendChild(active);
								}
		    					}
	    		    				if (dp.getNodeName().equals("HARVESTMETHOD")) 
							{
          							if (dp.getFirstChild()!=null)
								{
					    				harvestmethod.appendChild(doc1.createTextNode(dp.getFirstChild().getNodeValue()));
									dp2.appendChild(harvestmethod);		
								}
		    					}
		     					if (dp.getNodeName().equals("LASTHARVESTTIME")) 
							{
								if(yesflag==1)
									lastharvesttime.appendChild(doc1.createTextNode(harvesttime));
								else
									if(dp.getFirstChild()!=null)
						    				lastharvesttime.appendChild(doc1.createTextNode(dp.getFirstChild().getNodeValue()));
								dp2.appendChild(lastharvesttime);
		    					}
			    				if (dp.getNodeName().equals("WEBSITE")) 
							{
		                  			if (dp.getFirstChild()!=null)
								{
					    				website.appendChild(doc1.createTextNode(dp.getFirstChild().getNodeValue()));
									dp2.appendChild(website);
								}
			    				}
			    				if (dp.getNodeName().equals("SHORTNAME")) 
							{
		                  			if (dp.getFirstChild()!=null)
								{
					    				shortname.appendChild(doc1.createTextNode(dp.getFirstChild().getNodeValue()));
									dp2.appendChild(shortname);
								}
			    				}
						}
						dp1.appendChild(dp2);
	    				}
				}
			}	    			
		doc1.appendChild(dp1);
		}
		else
			System.out.println("root is null");
		try
		{
			OutputStreamWriter file=new OutputStreamWriter(new FileOutputStream("./conf/dps.xml"),"UTF-8");
	            Dom2Stream(doc1,file);
      	}catch (Exception e){System.out.println("Exception");}
	}
    /** main */
	public static void main(String args[])
	{
		XMLUpdater dpr = new XMLUpdater();
	}
}	
