package search;
import java.sql.*;
import java.io.*;

import java.net.*;
import java.util.*;

import ns.*;
import db.*;

public class AdvanceForm implements TimerListener 
{
	FormData data = null;
    ConnectionPool cpool;
    DetailDPReader dp;
    Hashtable archivelist;
    
    String htmlpage="<h4>Advanced Form is loading,please wait a while and try again";
    
    // Our Timer object
    db.Timer m_timer;
//////////////////////////////////////////
     public FormData getFormData ()
	{
	    /* if (data==null)
		{
			System.out.println ("Requesting null data");
			refresh (); 
			}
	    */
	    return data;
	}   	
//////////////////////////////////////////
    public AdvanceForm(ConnectionPool cpool,DetailDPReader dp)
    {
		this.cpool=cpool;
		this.dp=dp;
		m_timer = new db.Timer(this, 3600*12);
	        m_timer.start();
    }
//////////////////////////////////////////   	
    public void refresh()
    {

		//get the most recent archivelist
		dp.init();
		archivelist=dp.getHashedNamelist();
	
		Connection conn=cpool.getConnection();
		System.out.println("Reload Advanced Search Interface");
		data=new FormData(conn);
		cpool.close(conn);
		
		//htmlpage=createpage(data);
    }
//////////////////////////////////////////   	
	/**
    * <p>Called by the timer each time a clock cycle expires.
    * This gives us the opportunity to refresh advanced form.
    */
    public synchronized void TimerEvent(Object object)
    {
		refresh();
    }
//////////////////////////////////////////   	
    public String createpage(FormData data)
    {
		TreeSet treeset=null;
	
		String page= "<html><head>";
		
		for (Enumeration enum=data.archives.elements ();enum.hasMoreElements() ;) 
		{
		    String archive=(String)(enum.nextElement());
		    page+="if(x==\""+archive+"\"){\n";
		    TreeSet partitionoptions=(TreeSet)data.set.get(archive);
		    for(Iterator pointer=partitionoptions.iterator();pointer.hasNext();){
			page+="s1=s1+\"~"+(String)(pointer.next())+"\";\n";
		    }
		    page+="}\n";
		}
		
		
		
		
		for (Enumeration enum=data.archives.elements ();enum.hasMoreElements() ;) {
		    String archive=(String)(enum.nextElement());
		    String shortname;
		    try{
			shortname=((DPInfo)archivelist.get(archive)).name;
		    }
		    catch (Exception e){
			shortname=archive;
		    }
		    page+="<option value=\""+archive+"\">"+shortname+"</option>\n";
		}
				return page;
    }
//////////////////////////////////////////   	
	public void printform(PrintWriter out)
	{
		out.println(htmlpage);
		out.flush();
		out.close();
    }
//////////////////////////////////////////   	

}
