/*
 * @(#)AdvancedFormServlet
 *
 *
 * @author  Xiaoming Liu
 * @version 1.0
 * @date    24/10/2001
 *
 */

package search;

import javax.servlet.*;
import javax.servlet.http.*;

import db.*;
import ns.*;

/**
 * <p>This is a simple servlet that holds advanced Search form for arc. so that * other servlet (search) could use this form
 */

public class AdvancedFormServlet extends HttpServlet
{
    AdvanceForm form;

  // Context attribute key
    public static String KEY = "AdvancedFormServlet";
    public static String ADV_FORMDATA = "AdvancedFormServlet.AdvanceForm";


  /**
    * <p>Initialize the servlet. This is called once when the
    * servlet is loaded. It is guaranteed to complete before any
    * requests are made to the servlet
    *
    * @param cfg Servlet configuration information
    */
  public void init(ServletConfig cfg)
    throws ServletException
    {      
      super.init(cfg);
      ServletContext context=cfg.getServletContext();
      Object o=context.getAttribute(ConnectionServlet.KEY);
      if (o==null)
      {
      	System.out.println ("ConnectionServlet not started");
	  	throw new ServletException("ConnectionServlet not started");
      }

      ConnectionPool cpool=(ConnectionPool)o;
    
     
      o=context.getAttribute(Search.APP_DPDETAILREADER);
      if (o==null)
      {
      	System.out.println ("Search Servlet not started");
	  	throw new ServletException("Search Servlet not started");
      }
      
      
      DetailDPReader dp=(DetailDPReader)o;




      // Initialize the AdvancedForm. 
      try 
      {
	  	form=new AdvanceForm(cpool,dp);
      }
      catch (Exception ex) 
      {
        // Convert the exception
        ex.printStackTrace();
        throw new ServletException
          ("Unable to initialize connection pool");
      }

      // Add this servlet to the context so that other servlets
      // can find us
      getServletContext().setAttribute(ADV_FORMDATA, form);
     
      System.out.println("Form initialization is done");
    }

  /**
    * <p>Destroy the servlet. This is called once when the servlet
    * is unloaded.
    */

  public void destroy()
    {
      // Remove the attribute from the context
      getServletContext().removeAttribute(KEY);
      super.destroy();
    }

}

