package search;
// CLog.java
 
import java.io.*;
import java.util.*;
import java.lang.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;

import db.*;



public class CLog
{
    ConnectionPool cpool;
    /**
     * Constructor
     */
	public CLog (ConnectionPool cpool)
	{
        this.cpool=cpool;
	}


    public void add(HttpServletRequest  request,SearchParam param){
        Connection connection=null;
        PreparedStatement updatestmt=null;

        try{
            connection=cpool.getConnection();
            updatestmt = connection.prepareStatement("insert into querylog(hostname, accessdate, tablename,whereclause, sortclause, groupclause) values (?,?,?,?,?,?)");

            updatestmt.setString(1,request.getRemoteHost());
            java.util.Date today=new java.util.Date();
            updatestmt.setDate(2,new java.sql.Date(today.getTime ()));
            updatestmt.setString(3,param.getTableName()==null?"":param.getTableName());
            updatestmt.setString(4,param.getWhereClause()==null?"":param.getWhereClause ());
            updatestmt.setString(5,param.getSortClause()==null?"":param.getSortClause ());
            updatestmt.setString(6,param.getGroupClause()==null?"":param.getGroupClause ());
            updatestmt.executeUpdate();
        }catch(Exception e){
            System.out.println(e);
        }
        finally{
            try{
                updatestmt.close();
                cpool.close(connection);
            }
            catch(Exception ex){
                System.out.println(ex);
            }

        }
   }



}
