package search;
// class CResultDisplayer

import java.sql.*;
import java.io.*;
import java.util.*;
import ns.*;
import javax.servlet.*;
import javax.servlet.http.*;

class CResultDisplayer 
{
//////////////////////////////////////////////////////////////////////////	
	public final static String SESSION_METADATA="search.metadata";
	public final static String SESSION_LINKS="search.links";
	public final static String SESSION_QUERY="search.query";
	public final static String SESSION_SORTEDBY="search.sortedby";
	

	
    private int page_size;
    private int max_pgn = 20;      // we can initialize this one in constructor;
  
    private int numOfResult;
    private ArrayList fullResult;  // with each element to be a CMetaData object
    private ArrayList idCollection; // with each element to be a two element array: 
				    				// String id and String tag specifying table name
    private String page_header;
    private String search_result, search_result_header, search_title;
    private String rt_htm;
    
    private HttpSession session;
    HttpServletResponse response;
    HttpServletRequest request;

    private DBSearcher mySearcher;
    private String servleturl=null;
    
    Vector metadata_list;
//////////////////////////////////////////////////////////////////////////	
    public CResultDisplayer( DBSearcher searcher, int pg_sz,String url,
    			HttpSession session,HttpServletRequest request,HttpServletResponse response) 
    {
		metadata_list = new Vector ();
		session.removeAttribute (SESSION_LINKS);		
		page_size = pg_sz;
		rt_htm = "";
		
		this.session = session;
		this.request = request;
		this.response = response;
		mySearcher = searcher;
	    servleturl=url;
	    session.setAttribute (SESSION_SORTEDBY,mySearcher.sp.getSortTitle());
		/*search_result_header = "<table border=0 width=560 cellspacing=2 cellpadding=0 bgcolor=\"#FFFFFF\">"+
		    "<tr bgcolor=\"#000000\"> <td width=560 valign=\"top\" colspan=\"2\"> " +
		    "<font face=\"Arial, Helvetica, sans-serif\" size=\"3\"><b><font color=\"#FFFFFF\"> " +
		    "SEARCH RESULTS " 
			+(mySearcher.sp.getSortTitle()==null?"":"SORTED BY "+mySearcher.sp.getSortTitle()) 
			+(mySearcher.sp.getGroupTitle()==null?"":" GROUPED BY "+mySearcher.sp.getGroupTitle()) 
			+"</font></b></font></td> </tr> </table>";
		search_result = "";
		page_header = "<TITLE>Search Results</TITLE> <body bgcolor=\"#FFFFFF\">  ";
		*/
		
    }
	
/////////////////////////////////////////////////////////////////////////////////////////////////
    public void displayAll(Connection con) throws SQLException, IOException
    {
		int i, hit_num=0 ;
		CMetaData md;
		metadata_list = new Vector ();	
		session.removeAttribute (SESSION_LINKS);
		try
		{
			hit_num = mySearcher.GetNumHits();
		}
		catch (Exception e)
		{
			System.out.println ("hit_num="+hit_num);
			e.printStackTrace ();
		}
		//myout.print(page_header);
		//myout.print("<p>There is " + hit_num + " hits.");
		//myout.print(search_result_header);
		for(i=0;i<hit_num;i++)
		{    
		    md = mySearcher.getMetaData(con,i);
		    displayOneHit(md);
		}
    }

//////////////////////////////////////////////////////////////////////////////////////////////////
    public void displayPageN(int n,Connection con) throws SQLException, IOException
	{
	
		CMetaData md;
		metadata_list = new Vector ();	
		int hit_num=0;
		
		int beginn =  (n-1)*page_size;
		int endn   =   n * page_size-1;
		try
		{
			hit_num = mySearcher.GetNumHits();
		}
		catch (Exception e)
		{
			System.out.println ("hit_num="+hit_num);
			e.printStackTrace ();
		}
	
		if ( endn >= hit_num ) 
		{
		    endn = hit_num -1;
		}
	
		//myout.print(page_header);
	    if (hit_num==0)
	    {
	        //myout.print("<p><H3>No Search Result Returned</H3>");
	        return;
	    }
	 
		//myout.print(search_result_header);
	   int page_num ;
	   if (hit_num%page_size == 0)
	       page_num = hit_num/page_size;
	  	else page_num = (hit_num+page_size)/page_size;
	 	if ( hit_num > page_size )
		{
		  //myout.print("<p><H5>This is page " + n + " of total " + page_num +" pages"+
	      //          ", hits (" + (beginn+1) + "--" + (endn+1) +
		  //	      ") of total " + hit_num + " hits.</H5>");
		}
		
		int pgn, beginp, endp, last_pg;
		last_pg=(hit_num-1)/page_size;
	
		beginp = n - ((n-1)%max_pgn);
		endp = n-((n-1)%max_pgn) + max_pgn - 1;
	
		
		session.setAttribute (SESSION_LINKS,getPageLinks(page_size, hit_num, n, beginn, endn));  
		session.setAttribute (SESSION_QUERY,mySearcher.sp.getWhereClause());  
	 
		String g = mySearcher.sp.getGroupTitle(); 
		String sub_title=""; 
		md = mySearcher.getMetaData(con,0); 
	 
		/*if (g.indexOf ("DATE")>-1) 
		{ 
			try
			{
				sub_title = "DISCOVERY YEAR :"+md.normDiscovery.substring (0,4); 
			}
			catch (Exception e)
			{
				sub_title = "DISCOVERY YEAR : Misc";
				e.printStackTrace ();
			}
		} 
		else
		{ 
			sub_title= "ARCHIVE :"+md.archive; 
			search_title = "<table border=0 width=560 cellspacing=2 cellpadding=0 bgcolor=\"#FFFFFF\">"+ 
		    "<tr bgcolor=\"#000fff\"> <td width=560 valign=\"top\" colspan=\"2\"> " + 
		    "<font face=\"Arial, Helvetica, sans-serif\" size=\"3\"><b><font color=\"#FFFFFF\"> "  
		    +sub_title 
			+"</font></b></font></td> </tr> </table>";
		}
		*/
	 
	
		int i;
	
		for (i=beginn;i<=endn;i++) 
		{
		    md = mySearcher.getMetaData(con,i);
		    displayOneHit(md);
		}
	
	
		if (hit_num > page_size)
		    session.setAttribute (SESSION_LINKS,getPageLinks(page_size, hit_num, n, beginn, endn));  
	     session.setAttribute (SESSION_METADATA,metadata_list);
	     String display = (String)session.getAttribute("display");
	     String p = AttribSaver.getPage (display);
		 response.sendRedirect(request.getContextPath()+p);
	}

////////////////////////////////////////////////////////////////////

    public void displayOneHit( CMetaData md )
    {
		if (md==null)
		    return;

		metadata_list.add (md);
	}

////////////////////////////////////////////////////////////////////
    private String getPageLinks(int page_size, int hit_num, int n, int beginn, int endn)
    {

        
        String links = new String ("");
		int pgn, beginp, endp, last_pg;
	

		last_pg=(hit_num-1)/page_size;
		beginp = n - ((n-1)%max_pgn);
		endp = n-((n-1)%max_pgn) + max_pgn - 1;
		if ( n > max_pgn )
			links += "<a href=\"servlet/search?formname=page&page=" + (beginp-1) + "\">" + " [<< Prev] </a> ";
	
		for ( pgn=beginp; pgn<=endp && pgn<=last_pg; pgn++) 
		{
		  if ( n != pgn) 
		  {
		  	  links += 	"<a href=\"servlet/search?formname=page&page=" + pgn + "\">" + pgn + "</a> ";
		  } else {
		  	  links += 	pgn + " ";		  
		  }
		}
	
		if ( pgn > last_pg && (pgn-1)!=endp) 
		{
		  if ( n != pgn) 
		  {
		  	  links += "<a href=\"servlet/search?formname=page&page=" + pgn + "\">" + pgn + "</a> ";		      
		  } 
		  else 
		  {
		  	  links +=  pgn + " ";
		  
		  }
		  		 
		  return links;
		}
	
		if ( ((pgn-1)*page_size<hit_num) )
		{
			links += 	"<a href=\"servlet/search?formname=page&page=" + pgn + "\">" + " [Next >>] </a> ";		 
		}
			
		return links;
	 }

}


