package search;
import java.io.*;
import java.util.zip.*;
import java.util.*;
import java.lang.*;
import java.awt.event.*;
import javax.servlet.*;
import javax.servlet.http.*;
//import java.sql.*;
import java.text.*;

import db.*;
import ns.*;


public class DateUtil
{
	public static String format = "YYYY-MM-DD";
	
	
///////////////////////////////////////////////////	
	public HashSet formatDate (String date)
	{
		boolean field_locs [][] = new boolean [3][3]; // possible locations of year month and date
		                                              // field_locs [0] year
		                                              // field_locs [1] month
		                                              // field_locs [2] day
		                                              // eg.field_locs [2][1] is true when date can be in loaction 2(index 1)

		HashSet dates = new HashSet ();		                                              
		for (int i=0;i<3;i++)
		{
			Arrays.fill (field_locs[i],true);
		}
		// Parse the date
		StringTokenizer st = new StringTokenizer (date," /.,-:,;'\"}{[]|!~!@#$%^&*()+=");
		
		
		ArrayList a = new ArrayList ();
		while (st.hasMoreTokens ())
		{
			String val = st.nextToken();
			if (val.length()>0)
			{
				if (Character.isDigit(val.charAt(0)))
				{
					// Trim leading zeros
					Integer ii = new Integer(val);
					if (ii.intValue()>12)
					{
						int loc = a.size();
						//System.out.println ("Loc="+loc);
						
						field_locs [1][loc] = false;							
						
					}
					if (ii.intValue()>31)
					{
						int loc = a.size();
						//System.out.println ("Loc="+loc);
						field_locs [2][loc] = false;
						for (int i=0;i<3;i++)
						{
							
							if (i!=loc)
							{								
								field_locs[0][i] = false;
							}
						}
					}
					String num =ii.toString();
					if (ii.intValue()<10)
						num ="0"+num;
					
						
					a.add (num);
				}
				else
				{
					int m = getMonth (val);
					if (m>-1)
					{
						Integer ii = new Integer(m);
						int loc = a.size();
						for (int i=0;i<3;i++)
						{
							field_locs[0][loc] = false;
							field_locs[2][loc] = false;
							if (i!= loc)
							{
								field_locs[1][i] = false;
							}
						}
						a.add (ii.toString());
						
					}
				}
			}
		}
		
		String date_string = new String ("");
		for (int i=0;i<a.size();i++)
		{			
			date_string +="-";
			date_string += (String)a.get (i);	
		}
		if (date_string.length()>0)
			date_string = date_string.substring (1);
		
		//System.out.println ("Parsing :"+date_string);
		String [] patterns = new String [3]; 
		for (int i=0;i<3;i++)
		{
			patterns [i] = "y";
			for (int j=0;j<3;j++)
			{
				if (j!=i)
				{
					patterns [j] = "M";
					for (int k=0;k<3;k++)
					{
						if (k!=j && k!= i)
						{
							if (field_locs[0][i] & field_locs[1][j] & field_locs[2][k])
							{
								patterns [k] = "d";
								String pattern="";
								if (a.size()==1)
								{
									if (!field_locs[0][0])
										continue;
										pattern="y";
								}
								else
								if (a.size()==2)
								{
									
									if (i>=a.size() || j>=a.size())
										continue;
									if (i<j)
										pattern = "y-M";
									else
										pattern = "M-y";
									
								}
								else
								{
									pattern = patterns[0]+"-"+patterns[1]+"-"+patterns[2];
								}
								
								//System.out.println ("i="+i+",j="+j+",k="+k);
								//System.out.println ("Pattern="+pattern);
								SimpleDateFormat df = new SimpleDateFormat (pattern);
								try
								{
										
										Date d = df.parse (date_string);
										dates.add (d);
										//SimpleDateFormat of = new SimpleDateFormat ("MMM d, y");
										//StringBuffer sb = new StringBuffer ();
										//sb = of.format (d,sb,new FieldPosition(0));
										//System.out.println ("Date="+sb.toString()+"\n");
								}
								catch (Exception e)
								{
								}
							}
						}
					}
				}
			}
		}
		return dates;
		
	}
///////////////////////////////////////////////////	
	int getMonth (String month)
	{
		try
		{
			SimpleDateFormat df = new SimpleDateFormat ("MMM");
			SimpleDateFormat of = new SimpleDateFormat ("M");
			Date d = df.parse (month);
			StringBuffer sb = new StringBuffer ();
			sb = of.format (d,sb,new FieldPosition(0));
			return Integer.parseInt (sb.toString ());
		}
		catch (Exception e)
		{
			return -1;
		}
	}
///////////////////////////////////////////////////	
	public String getDateString (String a)
	{
		String ret = "";
		
		HashSet dates = formatDate (a);
		if (dates.size()==0)
		{
			
			return "Could not resolve date";
		}
		else
		{
			SimpleDateFormat of = new SimpleDateFormat ("MMM dd, yyyy");
			for (Iterator i=dates.iterator();i.hasNext();)
			{	
				Date d = (Date)i.next();
				String s = of.format (d);
				ret += s+"\n";
			}
		}

		return ret;
	}
///////////////////////////////////////////////////	

	public static void main (String args[])
	{
		DateUtil du = new DateUtil ();
		System.out.println (du.getDateString(args[0]));
	}
///////////////////////////////////////////////////	
}