/*
 * @(#)Group.java        01/02/15
 * Used for specify group informatoin
 */

package search;
import java.util.*;

/**
 * Group is used like "group" clause in SQL statement
 * In search engine, the search is done in two steps.
 * 1.Find number of different group, such as
 * select fieldname,count(*) from tablename group by fieldname
 *
 * 2.Find ids of all available record in one specific group, such as
 * select id from tablename where clause+ and fieldname=groupid.
 *
 * @version 	1.0 15 Feb 2000
 * @author 	Xiaoming Liu
 */


public class Group extends TreeMap{
    private String fieldname; //the group field name, such as archive or datestamp

    /**
     * get field name
     * @return field name
     */

    /**
     * Constructor
     * @param fieldname name of group
     */
    public Group(String fieldname){
        this.fieldname=fieldname;
    }


    public String getName()
    {
    	try
    	{	
    		fieldname = fieldname.trim().toLowerCase();
    		if (fieldname.indexOf ("discovery")>=0)
    			return "Date";
	    	char c = fieldname.charAt (0);
	    	c = Character.toUpperCase (c);
	    	//System.out.println ("First ="+c);
	    	String ret = c + fieldname.substring (1);
	    	//System.out.println ("Getting Group name="+ret);
	        return ret;
	    }
	    catch (Exception e)
	    {
	    	return fieldname;
	    }
    };
    
    /**
     * add a new group item
     * @param groupid
     * @param size size of this groupitem
     */

    public void add(String groupid,int size){
        put(groupid,new GroupItem(groupid,size));
    }
}

