package search;
import java.io.*;
import java.util.zip.*;
import java.util.*;
import java.lang.*;
import java.awt.event.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;

import db.*;
import ns.*;

public class Search extends HttpServlet
{

    public final static String SESSION_GROUP="search.group";
    public final static String SESSION_METADATA="search.metadata";
    public final static String SESSION_LINKS="search.links";
    public final static String SESSION_DBSEARCHER="search.dbsearcher";
    public final static String SESSION_SEARCHPARAM="search.param";
    public final static String APP_DPDETAILREADER="search.dpdetailreader";
    public final static String SESSION_CONN="search.conn";
    
    public final static String SESSION_SINGLE_METADATA="search.SingleMetadata";
    public final static String SESSION_SINGLE_METADATA_ARCHIVE="search.SingleMetadataArchive";
    public final static String SESSION_SINGLE_METADATA_NEXT="search.SingleMetadataNext";
    public final static String SESSION_SINGLE_METADATA_PREV="search.SingleMetadataPrev";
    public final static String CACHECFG="singlepage.cachecfg";

    private ConnectionPool cpool;
    public static Connection conn;
    private Hashtable archivelist;
    private Info info;
    private int dbtype;
    private CLog log;


	//////////////////////////////////////////////////////
    public void doGet (HttpServletRequest request,
                       HttpServletResponse response)
        throws ServletException, IOException
    {
        //PrintWriter out = response.getWriter();;
        
     	BufferedReader in;
        SearchParam search_param=null;
        Group group=null;
         	int page_num=1;
         // Keep stats for how long it takes to execute
      // the query
      String formname=request.getParameter("formname");
      HttpSession session = request.getSession(true);
 	  response.setContentType("text/html");
      long startMS = System.currentTimeMillis();

      if (formname.equals("info")) 
      {
      	PrintWriter out = response.getWriter();
        info.format(out);
        out.close ();
        return;
      }

      if (formname.equals("searchform")){
	  //  advanceform.printform(out);
        session.setAttribute(SESSION_CONN, conn);
	 //session.setAttribute(SESSION_ARCHIVELIST, archivelist);

        response.sendRedirect(request.getContextPath()+"/advanced_form.jsp");
        return;
      }

	  else if  (formname.equals("last"))
      {
        search_param=(SearchParam)session.getAttribute(SESSION_SEARCHPARAM);
        SizeSearcher ss=new SizeSearcher(search_param);
        
        Connection con=cpool.getConnection();
        Group g=ss.DoSearch (con,session);
        
        String   groupid="";
        try
        {
        	groupid=(String)g.firstKey ();
        	DBSearcher os = new DBSearcher (search_param,(GroupItem)(g.get(groupid)));
        	os.DoSearch (con);
        	session.setAttribute(SESSION_DBSEARCHER,os);
     		session.setAttribute(SESSION_GROUP,g);
        	session.setAttribute (SESSION_SEARCHPARAM,search_param);
        }
        catch (Exception ee)
        {
       		ee.printStackTrace();
       		response.sendRedirect (request.getContextPath()+"/noresults.html");
       		cpool.close (con);
       		return;
        }
        cpool.close (con);
        
        System.out.println ("Finished search");	          
        //response.sendRedirect(request.getContextPath()+"/results.jsp");
        //return;
      }

      else if  (formname.equals("simple"))
      {
        if (dbtype==ConnectionPool.ORACLE)
            search_param=new OracleSimpleParam(request);
        else
            search_param=new MysqlSimpleParam(request);
        log.add(request,search_param);
        SizeSearcher ss=new SizeSearcher(search_param);
        
        Connection con=cpool.getConnection();
        Group g=ss.DoSearch (con,session);
        
        String   groupid="";
        try
        {
        	groupid=(String)g.firstKey ();
        	DBSearcher os = new DBSearcher (search_param,(GroupItem)(g.get(groupid)));
        	os.DoSearch (con);
        	session.setAttribute(SESSION_DBSEARCHER,os);
     		session.setAttribute(SESSION_GROUP,g);
        	session.setAttribute (SESSION_SEARCHPARAM,search_param);
        }
        catch (Exception ee)
        {
       		ee.printStackTrace();
       		response.sendRedirect (request.getContextPath()+"/noresults.html");
       		cpool.close (con);
       		return;
        }
        cpool.close (con);
        
        System.out.println ("Finished search");	          
        //response.sendRedirect(request.getContextPath()+"/results.jsp");
        //return;
      }

      else if (formname.equals("advance"))
      {
        if (dbtype==ConnectionPool.ORACLE)
    	    search_param = new OracleAdvancedParam(request);
        else
            search_param=new MysqlAdvancedParam(request);
        log.add(request,search_param);

        SizeSearcher ss=new SizeSearcher(search_param);
        Connection con=cpool.getConnection();
        Group g=ss.DoSearch (con,session);
        //****************
        // Put Group data 
        //****************
        try
        {
	        String   groupid=(String)g.firstKey ();
	        DBSearcher os = new DBSearcher (search_param,(GroupItem)(g.get(groupid)));
	        os.DoSearch (con);
	        
	        session.setAttribute(SESSION_DBSEARCHER,os);
	     	session.setAttribute(SESSION_GROUP,g);
	        session.setAttribute (SESSION_SEARCHPARAM,search_param);
	     }
	     catch (Exception ea)
	     {
	     	ea.printStackTrace ();	
			response.sendRedirect(request.getContextPath()+"/noresults.html");
			cpool.close (con);
			return;
		 }
		cpool.close (con);
		
      }

      else if (formname.equals("browse"))
      {
          group=(Group)session.getAttribute(SESSION_GROUP);
          if ((group==null)||(group.size()==0))
               response.sendRedirect(request.getContextPath()+"/noresults.html");
          else
          {
              SearchParam param=(SearchParam)session.getAttribute(SESSION_SEARCHPARAM);
              String groupid=request.getParameter("groupid");
              if (groupid==null)
                groupid=(String)group.firstKey ();
              System.out.println("In browser: groupid"+groupid+"| size"+((GroupItem)group.get(groupid)).size);

              DBSearcher os = new DBSearcher (param,(GroupItem)(group.get(groupid)));
		      Connection con = cpool.getConnection ();
              os.DoSearch (con);
              System.out.println ("Finished search");
	          cpool.close (con);
              session.setAttribute(SESSION_DBSEARCHER,os);
          }
      }

      else if (formname.equals("detail"))
      {
        String id=null;
        try
        {
            id=java.net.URLDecoder.decode(request.getParameter("id"));
            System.out.println("id="+id);
        }
        catch (Exception e)
        {
            throw new ServletException("detail page error");
        }
      	Connection con = (Connection) cpool.getConnection ();
	
        CMetaData metadata=DBSearcher.getMetaData(con,id);
        if (metadata==null)
        {
            throw new ServletException("detail page error");
        }
        session.setAttribute(SESSION_SINGLE_METADATA, metadata);
        session.setAttribute(SESSION_SINGLE_METADATA_ARCHIVE,(DPInfo)(archivelist.get(metadata.archive)));
        DBSearcher os = (DBSearcher)session.getAttribute(SESSION_DBSEARCHER);
        int index = os.getIndex (id);
        int hits = os.GetNumHits ();
        
        if (index+1<hits)
        {
        	
        	CMetaData next=os.getMetaData(con,index+1);
        	session.setAttribute(SESSION_SINGLE_METADATA_NEXT,next.id);
        }
        else
        	session.setAttribute(SESSION_SINGLE_METADATA_NEXT,null);
        	
        if (index-1>=0)
        {
        	
        	CMetaData prev=os.getMetaData(con,index-1);
        	session.setAttribute(SESSION_SINGLE_METADATA_PREV,prev.id);
        }
        else
        	session.setAttribute(SESSION_SINGLE_METADATA_PREV,null);	
        
        //PrintWriter out = response.getWriter();;
        //SinglePage.format(out,metadata,((DPInfo)(archivelist.get(metadata.archive))));
        //out.flush ();
        //out.close ();
        cpool.close(con);
        response.sendRedirect(request.getContextPath()+"/single_page.jsp?id="+metadata.id);
        
        return;
      }
      else 
      {
        	String page = request.getParameter("page");

			if (page != null)
			{
				Integer i = new Integer(page);
				page_num = i.intValue();
			}
			else
			{
				page_num = 1;
			}

      }


    try
	{
     		DBSearcher os = (DBSearcher)session.getAttribute(SESSION_DBSEARCHER);
     		if (os ==null)
     		{
     			
     			//*******
     			SearchParam param=(SearchParam)session.getAttribute(SESSION_SEARCHPARAM);
	          	String groupid=request.getParameter("groupid");
	          	if (groupid==null)
	          	{
	          		if (group==null)
	          		{
	          			if (search_param!=null)
	          			{
		          			SizeSearcher ss=new SizeSearcher(search_param);
	        				Connection con2=cpool.getConnection();
	        				group=ss.DoSearch (con2,session);
	        				cpool.close (con2);
	        			}
	          		}
	          		
	            	groupid=(String)group.firstKey ();
	            }
	          	System.out.println("In browser: groupid"+groupid+"| size"+((GroupItem)group.get(groupid)).size);
	
	          	os = new DBSearcher (param,(GroupItem)(group.get(groupid)));
			    Connection con = cpool.getConnection ();
	          	os.DoSearch (con);
	          	System.out.println ("Finished search");
		        cpool.close (con);
	          	session.setAttribute(SESSION_DBSEARCHER,os);
	          	//**********
     		}
            String servleturl=HttpUtils.getRequestURL(request).toString();        
			CResultDisplayer rd = new CResultDisplayer (os,20,servleturl,session,request,response);
			Connection con = (Connection) cpool.getConnection ();

			rd.displayPageN (page_num,con);
            cpool.close(con);

			///////////////////////////
			// close the search
			// os.closeConnection ();
			//////////////////////////
			//out.close();
	}

	catch (Exception e)
	{
		PrintWriter out = response.getWriter();
	    e.printStackTrace ();	
	    response.sendRedirect (request.getContextPath()+"/noresults.html");
		/*out.println("<html>" +
			    "<head><title>Error</title></head><body>" );
		out.println ("<h1>");
		out.println (e);
		out.println (" </h1>");
		out.println("</body></html>");
		out.close ();*/

	}
    long elapsed = System.currentTimeMillis() - startMS;
    info.click(elapsed);

	return;

    }


    //////////////////////////////////////////////////////
    public void init (ServletConfig config) throws ServletException
    {


        ServletContext context=config.getServletContext();
        Object o=context.getAttribute(ConnectionServlet.KEY);
        if (o==null){
            throw new ServletException("ConnectionServlet not started");
        }

        cpool=(ConnectionPool)o;


        DetailDPReader dpreader=new DetailDPReader(cpool);
        dpreader.init();
	archivelist=dpreader.getHashedNamelist();
	context.setAttribute(APP_DPDETAILREADER,dpreader);

        dbtype=cpool.getDBType();

	Cache cache=(new CacheCfg(cpool)).getCache();
	context.setAttribute(CACHECFG,cache);

        info=new Info();
        log=new CLog(cpool);
    }

    //////////////////////////////////////////////////////
    public void destroy()
    {
        if (cpool!=null)
            cpool.destroy();
        super.destroy();
    }

    //////////////////////////////////////////////////////
    public String getServletInfo() {
        return "The Display Servlet";
    }
}
