/*
 * @(#)SearchParam.java 02/15/2001
 *
 */
package search;

/**
 * Search Param should be implemented by all search interface
 * @version 1.0
 * @author xiaoming liu
 *
 */
////////////////////////////////////////////////
public abstract class SearchParam 
{
    /**
     * whereClause is the part of where statement, like where archive='xxx'
     */
    protected String whereClause;
    /**
     * sortClause is the part of sort statement, like (sort by archive)
     */
    protected String sortClause;

     /**
      * groupClause is the part of group statment, like (group by archive)
      */

    protected String groupClause;
    public String mark_creator="";
    public String mark_title="";
    public String mark_description="";
////////////////////////////////////////////////    
    /**
     * get table name
     */   
    public abstract String getTableName();

    /**
     * get Where clause
     */
////////////////////////////////////////////////
    public String getWhereClause()
    {
        return whereClause;
    }
////////////////////////////////////////////////
    /**
     * get sort clause
     */
    public String getSortClause()
    {
        return sortClause;
    }
////////////////////////////////////////////////
	public String getSortTitle()
	{
		if (sortClause==null)
			return null;
        if (sortClause.indexOf ("discovery")>-1)
			return "DATE";
		if (sortClause.indexOf ("archive")>-1)
			return "ARCHIVE";
		return null;
    }
////////////////////////////////////////////////
    /**
     * get group clause
     */
    public String getGroupClause()
    {
        return groupClause;
    }
////////////////////////////////////////////////
	public String getGroupTitle()
	{
		if (groupClause==null)
			return null;
        if (groupClause.indexOf ("discovery")>-1)
			return "DATE";
		if (groupClause.indexOf ("archive")>-1)
			return "ARCHIVE";
		return null;
    }
////////////////////////////////////////////////
    public String toString()
    {
        return whereClause+" "+ sortClause+ " "+groupClause;
    }
////////////////////////////////////////////////
    /**
     * padd non-numalpharic character
     * if special character must be padded, otherwise SQL statement could not correctly run.
     * @param input input string
     * @return padded string
     */
    public static String padSpecialChar(String input)
    {
        	if (input==null)

		        return null;
        	StringBuffer buffer=new StringBuffer();
    	    for (int i=0;i<input.length();i++){
/*	            if (((input.charAt(i)>=65)&&(input.charAt(i)<=90))||((input.charAt(i)>=97)&&(input.charAt(i)<=122))||(input.charAt(i)==32))
    	    	    buffer.append(input.charAt(i));
	            else
    		    buffer.append("\\").append(input.charAt(i));*/
                if (input.charAt(i)=='\'')
                    buffer.append("''");
                else
                    buffer.append(input.charAt(i));
	        }
    	return buffer.toString();
    }


}
