package search;
import java.io.*;
import java.util.*;
import java.net.*;

import ns.*;

public class SinglePage {
    private long time=0;
    private int count=0;
    private long max=0;

    public static void format(PrintWriter out, CMetaData metadata,DPInfo archive){
        out.println("<html><head><title>"+metadata.title+"</title></head><body bgcolor=white text=\"#000000\" link=\"#CE6500\" vlink=\"#CE6500\" alink=\"#CE6500\">");
        out.println("  <SCRIPT LANGUAGE=\"JavaScript\"> if (top.frames.length > 0 )");
        out.println(" top.location = document.location </SCRIPT> <table border=0>");

    


        if ((metadata.archive!=null)&& (!metadata.archive.equals(""))){
            out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	    	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Source DL:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            if ((archive!=null)&&(archive.homepage!=null)){
                out.println("<a href="+archive.homepage+" target=_blank>");
                out.println(metadata.archive+"</a></font>");
            }
            else
                out.println(metadata.archive+"</font>");

        }

         if ((metadata.identifier!=null)&& (!metadata.identifier.equals(""))){
            StringTokenizer st=new StringTokenizer(metadata.identifier,"|");
            for(;st.hasMoreTokens ();){
                String url=st.nextToken();
                out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	        	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Identifier</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
			//validate url format
			try{
			    URL u=new URL(url);
			    out.println("<a href='"+ url+"'>"+url +"</a></font>");
			}
			catch (Exception e){
			    out.println(url+"</font>");
			}
            }
        }

        if ((metadata.cache!=null)&&(metadata.cache.equals("Y"))){
            out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	    	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>cached version:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");

            String filename=metadata.id.replace('/','.');
            filename=filename.replace('\\','.');
            filename=filename.replace(' ','.');
            filename=filename.replace(':','.')+metadata.identifier.substring(metadata.identifier.lastIndexOf("."));
            String url="../cache/"+filename;
            out.println("<a href="+url+">"+filename+"</a></font>");
        }


       

        if ((metadata.title!=null)&& (!metadata.title.equals(""))){
            out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	    	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Title:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            out.println(metadata.title+"</font>");
        }

        if ((metadata.creator!=null)&& (!metadata.creator.equals(""))){
            StringTokenizer st=new StringTokenizer(metadata.creator,"|");
            for(;st.hasMoreTokens ();){
                out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	        	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Author:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
                out.println(st.nextToken()+"</font>");
            }
        }

        if ((metadata.subject!=null)&& (!metadata.subject.equals(""))){
            StringTokenizer st=new StringTokenizer(metadata.subject,"|");
            for(;st.hasMoreTokens ();){
                out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	        	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Subject:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
                out.println(st.nextToken()+"</font>");
            }
        }


       if ((metadata.getDescription()!=null)&& (!metadata.getDescription().equals(""))){
            out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	    	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Abstract:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            out.println(metadata.getDescription()+"</font>");
        }

        if ((metadata.publisher!=null)&& (!metadata.publisher.equals(""))){
            out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	    	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Publisher:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            out.println(metadata.publisher+"</font>");
        }

        if ((metadata.contributor!=null)&& (!metadata.contributor.equals(""))){
            out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	    	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Contributor:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            out.println(metadata.contributor+"</font>");
        }

        if ((metadata.discovery!=null)&& (!metadata.discovery.equals(""))){
            out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	    	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Discovery:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            out.println(metadata.discovery+"</font>");
        }

        if ((metadata.type!=null)&& (!metadata.type.equals(""))){
            out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	    	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Type:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            out.println(metadata.type+"</font>");
        }

        if ((metadata.format!=null)&& (!metadata.format.equals(""))){
            StringTokenizer st=new StringTokenizer(metadata.format,"|");
            for(;st.hasMoreTokens ();){
                out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	        	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Format:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
                out.println(st.nextToken()+"</font>");
            }
        }



        if ((metadata.source!=null)&& (!metadata.source.equals(""))){
            out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	    	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Source:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            out.println(metadata.source+"</font>");
        }

        if ((metadata.language!=null)&& (!metadata.language.equals(""))){
            out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	    	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Language:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            out.println(metadata.language+"</font>");
        }


        if ((metadata.relation!=null)&& (!metadata.relation.equals(""))){
            out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	    	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Relation:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            out.println(metadata.relation+"</font>");
        }

        if ((metadata.coverage!=null)&& (!metadata.coverage.equals(""))){
            out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	    	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Coverage:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            out.println(metadata.coverage+"</font>");
        }


        if ((metadata.rights!=null)&& (!metadata.rights.equals(""))){
            out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	    out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Rights:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            out.println(metadata.rights+"</font>");
        }

	out.println("<TR><TD align=right bgColor=red vAlign=top><FONT face=\"Verdana, Arial, Helvetica, sans-serif\"><I>OAI Info</I></FONT><TR>");

	if ((metadata.id!=null)&& (!metadata.id.equals(""))){
	    out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	    out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>ID:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            out.println(metadata.id+"</font>");
        }

	if ((metadata.sets!=null)&& (!metadata.sets.equals(""))){
            StringTokenizer st=new StringTokenizer(metadata.sets,"|");
            for(;st.hasMoreTokens ();){
                out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	        	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Set:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
                out.println(st.nextToken()+"</font>");
            }
        }


         if ((metadata.datestamp!=null)&& (!metadata.datestamp.equals(""))){
            out.println("<tr> <td bgcolor=#999966 valign=top align=right>");
	    	out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>DateStamp:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            out.println(metadata.datestamp+"</font>");
        }
	if ((metadata.status!=null)&& (!metadata.status.equals(""))){
	    out.println("<tr> <td bgcolor=#E7E7E7 valign=top align=right>");
	    out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\"><i>Status:</i></font><td><font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            out.println(metadata.status+"</font>");
        }
		 out.println("<TR><TD align=right rowspan=2 bgColor=red vAlign=top><FONT face=\"Verdana, Arial, Helvetica, sans-serif\"><I>Service</I></FONT>");

	
	 out.println(" <td><a href=\"http://arc.cs.odu.edu:8080/dp9/service.jsp?identifier="+metadata.id+"\"><img src=\"../image/dp9.gif\">");
	
	    out.println("<font face=\"Verdana, Arial, Helvetica, sans-serif\">");
            out.println("Link to other services and metadata format</font></td></tr>");
	
        out.println("</table></body></html>");
        out.close();

   }

}
