package search;
import java.sql.*;
import java.lang.*;

import javax.servlet.*;
import javax.servlet.http.*;

public class SizeSearcher 
{
    SearchParam sp;
	//////////////////////////////////////////
    public SizeSearcher(SearchParam param) 
    {
        sp=param;
    }
	//////////////////////////////////////////
    /** Search Size
     * @param con -- established JDBC connection
     * @return group with size information
     */	
    public Group DoSearch(Connection con, HttpSession session)
    {
    	try
    	{
	    	ResultSet rset;
	    	String gname = sp.getGroupClause();
	        Group group=new Group(gname);
	        String sql;
	        Statement stmt = null;
	        GroupStatus gs = new GroupStatus ();
			
			String range= (String) session.getValue(search.AttribSaver.SESSION_ARCHIVE_RANGE);
			
			gname = gname.toLowerCase();
			//boolean alpha = true; // Alphabetic
			gs.alpha = true;
			if (gname.indexOf ("discovery")>=0 || gname.indexOf ("date")>=0)
			{			
				gs.alpha = false;
			}
			if (range==null)
			{
				range = gs.alpha?"AZ":"1";
			}
			if (gs.alpha && Character.isDigit (range.charAt(0)))
				range = "AZ";
			if (!gs.alpha && Character.isLetter (range.charAt(0)))
				range = "1";	
	        //create sql stmt
	        sql="select "+sp.getGroupClause()+", count(*) from "+ sp.getTableName()+" "+
	        (sp.getWhereClause()==null?"":sp.getWhereClause ())+" group by "+(sp.getGroupClause()==null?"":sp.getGroupClause ());
	
	        System.out.println(sql);
	        try
	        {
	            stmt = con.createStatement();
		    ResultSet rs = stmt.executeQuery(sql);
	            ResultSetMetaData rsmd=rs.getMetaData();
	            while (rs.next()) 
	            {
	                String id;
	                if (rsmd.getColumnType(1)==java.sql.Types.NUMERIC)
	                    id=Integer.toString(rs.getInt(1));
	                else
	                    id=rs.getString(1);
	                int size=rs.getInt(2);
	                if ((id!=null) && id.length()>=1)
	                {
			    System.out.println(id+" "+size);
	                	id = id.trim ();
	                	char c = id.charAt (0);
	                	gs.setStatus (id);
	                	if (gs.alpha) 
	                	{
	                		c = Character.toUpperCase (c);
	                		
	                		if (c>=range.charAt(0) && c<=range.charAt (1))
	                		{
	                			group.add(id,size);	
	                		}
	                	}
	                	else
	                	{
	                		int date_range = Integer.parseInt (range);
	                		int current_date=-1;
	                		try 
					 		{
								current_date = Integer.parseInt (id);
								if (current_date>2010)
								  current_date = -1;
							 }
							 catch (Exception e)
							 {
							     e.printStackTrace();
							 }
							 if ((date_range==1) ||
							   (date_range==2 && current_date>=1900 &&current_date<=1980)  ||
							   (date_range==3 && current_date>1980 && current_date<=1990 )  ||
							   (date_range==4 && current_date>1990 && current_date<=2000 )  ||
							   (date_range==5 && current_date>2000 && current_date<=2010 )  ||
							   (date_range==6 && (current_date==-1 || current_date<1900)))
							   {
							   		group.add(id,size);	
							   }
	                	}
	 	    	    	
	 	    	    }
	               
	            }
	            rs.close();
	            stmt.close();
	            session.setAttribute("GroupStatus", gs);
	        }
	        catch(Exception e){
	            e.printStackTrace ();
	        }
	        if (group.size()==0)
	        	session.removeAttribute (AttribSaver.SESSION_ARCHIVE_RANGE);
	        return group;
	  
	     }
	     catch (Exception e1)
	     {
		 e1.printStackTrace();
	     	session.removeAttribute (AttribSaver.SESSION_ARCHIVE_RANGE);
	     	return null;
	     }
    }
	//////////////////////////////////////////

}
