package search;


import java.sql.*;
import java.io.*;
import java.util.*;
import ns.*;

public class Utils
{
	////////////////////////////////////////////////////////////////////
	public static String highlightText (String src,String words)
	{
		String st = "<span style=\"background-color: #FFFF00\">";
		String end = "</span>";
		if (words==null)
		  return src;
		
		words = words.trim ().toLowerCase();
		if (words.length ()==0)
		  return src;
		String t = src;
		//System.out.println (src);
		int loc = t.toLowerCase ().indexOf (words);
		//int c=0;
		while (loc>-1)
		{
			//System.out.println (loc);
			StringBuffer sb = new StringBuffer (t);
			sb.replace (loc,loc+words.length(),
			           st+
			           t.substring (loc,loc+words.length())			   
			           +end);
			t = sb.toString ();           
			loc += st.length()+words.length()+end.length()-1;
			loc = t.toLowerCase ().indexOf (words,loc);
			//System.out.println ("Loc = "+loc+" "+t);
			//c++;
			//if (c>10)
			// break;
			           
		}
		return t;
	}
////////////////////////////////////////////////////////////////////
	public static String extractText (String src,String words,int max_seg,int maxlen)
	{
		int seg_num=0;
		int av=0;
		String list [] = {};
		try
		{
			int w = words.length ();
			if (src==null)
			  return src;
			  
			if (src.length()<maxlen)
			  		return src;
			if (words==null)
				return src.substring (0,maxlen);
			if (words.length()==0)
				return src.substring (0,maxlen);
			
			String regex = new String ("");
			words = words.toLowerCase ();
			for (int i=0;i<words.length();i++)
			{
				char c = words.charAt (i);
				regex += "["+c+Character.toUpperCase (c)+"]";
			}
			//System.out.println ("Regex : "+regex);
			list = src.split (regex);
			//System.out.println ("String splitted");
			
			seg_num = Math.min (max_seg,list.length);
			av = 1+(maxlen-3*seg_num)/(seg_num+1);
			String res = new String ("");
			
			int loc = 0;
			int n=0;
			//System.out.println ("Length = "+list.length);
			//System.out.println ("seg_num = "+seg_num);
			for (int i=0;i<seg_num;i++)
			{
				//System.out.println ("List :"+list[i]);
				
				
				n =list[i].length(); 
				//System.out.println ("n = "+n);
				loc += n;
				if (n!=0)
				{
					if (n>2*av)
					{
						if (i!=0)
						{
							int limit = (i<seg_num-1)?n/2:n; 
							res+= list[i].substring (0,av-1)+
							      getRestOfWord (list[i],av,av-2,limit)+".. ";
						}
						
						if (i<list.length-1)
							res += " .."+getStartOfWord (list[i],av,n-av-1,0)+
							      list[i].substring (n-av-1);
						
						String remain = new String (""); // The remaing of the current word
						
					}
					else
						res += list [i];
				}
				if (i<list.length-1)
					res += src.substring (loc,loc+w);
				//res += words;
				loc += w;		
				//System.out.println ("Res :"+ res);
			}
			
			n =list[seg_num-1].length(); 
			//System.out.println ("n = "+n);
			if (seg_num<list.length)
			{
				av = Math.min (av,list[seg_num-1].length());
				res += list[seg_num-1].substring (0,av-1);
				res +=getRestOfWord (list[seg_num-1],av,av-2,n)+".. ";
			}
			
			return res;
		}
		catch (Exception e)
		{
			System.out.println ("seg_num="+seg_num);
			System.out.println ("list length="+list.length);
			System.out.println ("av="+av);
			e.printStackTrace ();
		}
		return null;
	}
////////////////////////////////////////////////////////////////////
	private static String getRestOfWord (String s,int av,int pos,int limit)
	{
		try
		{
			limit = Math.min (s.length(),limit);
			String remain = new String ("");
			char c = s.charAt (pos);
			//System.out.println (s.substring (0,limit));
			if (Character.isLetter (c))
			{
				
				pos++;
			
				
				//System.out.println ("Pos ="+pos+" Limit="+limit);
				while (pos<limit)
				{
					c = s.charAt (pos);
					pos ++;
					if (Character.isLetter (c))
					{
						//System.out.println ("c="+c);
						remain += c;
						//System.out.println ("remain="+remain);
					}
					else
					{
						//System.out.println ("");
						return remain;
					}
				}
			}
			//System.out.println ("");
			return remain;
		}
		catch (Exception e)
		{
			return "";
		}
	}
	
////////////////////////////////////////////////////////////////////	
private static String getStartOfWord (String s,int av,int pos,int limit)
	{
		try
		{
			String remain = new String ("");
			char c = s.charAt (pos);
			//System.out.println (s.substring (0,limit));
			if (Character.isLetter (c))
			{
				
				pos--;
			
				
				//System.out.println ("Pos ="+pos+" Limit="+limit);
				while (pos>limit)
				{
					c = s.charAt (pos);
					
					pos --;
					if (Character.isLetter (c))
					{
						//System.out.println ("c="+c);
						remain = c+remain;
						//System.out.println ("remain="+remain);
					}
					else
					{
						//System.out.println ("");
						return remain;
					}
				}
			}
			//System.out.println ("");
			return remain;
		}
		catch (Exception e)
		{
			return "";
		}
	}
	
////////////////////////////////////////////////////////////////////
	public static String extract (String src,String words,int maxlen,int max_seg)
	{
		if (src==null)
			return src;
		if (words==null)
		{
			if (src.length()<= maxlen)
				return src;
			return src.substring (0,maxlen-3)+"...";
		}		
		String s = extractText (src,words,max_seg,maxlen);		
		//System.out.println ("Returning :"+s);		
		return highlightText (s,words);
	}
////////////////////////////////////////////////////////////////////
	public static String translateQuery (String query)
	// Translate the where clause of the Query
	{
		//System.out.println ("Query="+query);
		if (query==null)
			return "Get All Records";
		query = query.trim ();
		if (query.length()==0)
			return "Get All Records";
		try
		{
			
			String ret = new String ("");
			String prefix= "";
			boolean f = false;
			
			int loc = 0;
			
			while (loc>=0)
			{
				loc = query.indexOf ("contains",loc);
				String s ="";
				if (loc>0)
				{
					s = 	query.substring (loc);
					System.out.println ("s="+s);
					loc ++;
					StringTokenizer st = new StringTokenizer (s,"(,");
					String item = st.nextToken ();
					item = st.nextToken ();
					st = new StringTokenizer (s,"'");
					String term = st.nextToken ();
					term = st.nextToken ();
					if (item.equals("alltext"))
						ret += "Search for "+term+" ";
					else					
						ret +=item+"="+term;					
					
				}
				
				StringTokenizer t = new StringTokenizer (s,">0");
				
				String op ="";
				if (t.hasMoreTokens())
				{
				 op= t.nextToken ();
				 op = "";
				 if (t.hasMoreTokens())
				 	op= t.nextToken ();
				 op = op.trim ();	
				}
				t = new StringTokenizer (op," ");
				if (t.hasMoreTokens())
					op = t.nextToken();
				else 
					op = "";
				op = op.trim().toLowerCase ();	
				if (op.equals ("and"))
				{
					
					if (!f)
						prefix = "Search for records containing all of: ";				
					//ret += op+" ";					
					ret +=",";
					f= true;
				}
				else
				if (op.equals ("or"))	
				{
					if (!f)
						prefix = "Search for records containing any of: ";
					
					//ret += op+" "; 
					ret += ", "; 
					f = true;
					
				}	
		
				
			}
			return prefix+ret;
		}
		catch (Exception e)
		{
			e.printStackTrace ();
			return query;
		}
	}
////////////////////////////////////////////////////////////////////
	public static String adjustLength (String src,int max_length)
	{
		if (src==null)
			return "";
		String ret = src.trim();	
		if ( src.length() > max_length )
			ret = src.substring(0, max_length-3) + "...";	
		return ret;	
	}	
////////////////////////////////////////////////////////////////////
	public static void main (String args[])
	{
		//System.out.println 
		//(translateQuery ("where contains(creator, 'jones',1)>0 and contains (title, 'physics',2)>0 and  archive  ='CERN'  order by  score(1)"));
	}
////////////////////////////////////////////////////////////////////

}
