
import java.sql.*;
import java.net.*;
import java.io.*;
import java.util.*;
import java.sql.*;

/*
*
* testcase tests foreign language texts
* texts are read from xml-file unikoe.xml
* where the texts are in name elements
*
*
*
* Database table must be created manually.

	create table utfdata (
	  rowno int primary key auto_increment,
	  id varchar(255),
	  data varchar(255),
	  latin varchar(255),
	  description varchar(255)
	);  




* The utfkoe.xml contains 5 names in foreign languages
* 1. Kaarle nis Ilmari . This is in Latin1 and should pass for all
* 2. Michail Gorbatchov . This is in cyrillic characterset and passes only if UTF-8 is OK
* 3. Ramprasad          . This is written in an Indian characterset. Should pass if UTF-8 is OK
* 4. Mostafa            . This is in Arabic. Shoud pass is UTF-8 OK
* 5. Water              . This is chinese. Should pass if UTF-8 is OK.
*/

public class TestUnicode {
	
	
	Connection con = null;
	
 
//
//  select only one driver from here
// 
//	private static String driver = "com.mysql.jdbc.Driver";
	private static String driver = "org.gjt.mm.mysql.Driver";


// select only one url from here

//	private static String url = "jdbc:mysql://localhost/test";
	private static String url = "jdbc:mysql://128.dd.dd.ddd/oai20?user=&password=&useUnicode=true&characterEncoding=UTF-8";
//	private static String url = "jdbc:mysql://localhost/test?useUnicode=false&characterEncoding=UTF-8";



//    private static String name0 = "\u004b\u0061\u0061\u0072\u006c\u0065 \u00c4\u00e4\u006e\u0069\u0073 \u0049\u006c\u006d\u0061\u0072\u0069";
    private static String name0 = "Kaarle nis Ilmari";
    // name1 in Latin alphabet is Michail Gorbatjov (Cyrillic characters)
    private static String name1 = "\u041c\u0438\u0445\u0430\u0438\u043b \u0413\u043e\u0440\u0431\u0430\u0447\u0451\u0432";
    // name2 in Latin Alphabet is Ramprasad (in Telugu character set from India)
    private static String name2 = "\u0c30\u0c3e\u0c02\u0c2e\u0c4d\u0c35\u0c2a\u0c3e\u0c26\u0c4d";
    // name3 in Latin Alpabet is Mostafa (Arabic alphabet)
    private static String name3 = "\ufef0\ufed3\ufec3\ufebb\ufee3";
    // name4 is the character that means water in the chinese alphabet
    private static String name4 = "\u6c34";


	private static String latin0 = "Kaarle nis Ilmari";
	private static String latin1 = "Michail Gorbatchov";
	private static String latin2 = "Ramprasad";
	private static String latin3 = "Mostafa";
	private static String latin4 = "Water";

	private static String desc0 = "This is in Latin1 and should pass for all";
	private static String desc1 = "This is in cyrillic characterset and passes only if UTF-8 is OK";
	private static String desc2 = "This is written in Telugu, an Indian characterset. Should pass if UTF-8 is OK";
	private static String desc3 = "This is in Arabic. Should pass if UTF-8 OK";
	private static String desc4 = "This is chinese. Should pass if UTF-8 is OK";


    
    private String names[];
    private String latins[];
    private String descs[];
    private String xmldata;

	public static void main(String[] args) throws Exception{
	TestUnicode test=new TestUnicode("test");
	test.xmldata=readXML();
	test.setUp();
	test.testNames();	
} 
	public TestUnicode(String text) {
	}

	private Connection makeConnection(){
        
        try {
        	Class.forName(driver);			        	
            Connection conn = DriverManager.getConnection(url);
            return conn;       
		}
		catch (Exception ex) {
			ex.printStackTrace();
		}
		return null;
        	
    }
	
	
	private void connect() throws SQLException {
		con = makeConnection();
	}
	
	public void setUp() throws Exception {
		connect();
		Statement stm = con.createStatement();
		stm.executeUpdate("delete from utfdata");
		stm.close();
	    names = new String[5];
	    names[0] = name0;
	    names[1] = name1;
	    names[2] = name2;
	    names[3] = name3;
	    names[4] = name4;
	    latins = new String[5];
	    latins[0] = latin0;
	    latins[1] = latin1;
	    latins[2] = latin2;
	    latins[3] = latin3;
	    latins[4] = latin4;
		descs = new String[5];
		descs[0] = desc0;
		descs[1] = desc1;
		descs[2] = desc2;
		descs[3] = desc3;
		descs[4] = desc4;
		
	}	
		
	public void testConnection() throws SQLException {
		connect();
		con.close();
		con=null;
	}	
	
	
	public void testNames() throws Exception {
		int i,j,h;
		String tmp,id,data;
		Statement stmt;
		ResultSet rs;
		
		
		for (i = 0;i < 5;i++) {		    
			insertUtfData("key"+i,names[i],latins[i],descs[i]);		
		}
		
//
// now check the result
//
		
		stmt = con.createStatement();
		rs = stmt.executeQuery("select * from utfdata order by id");
		i=0;
		while (rs.next()){
			id = rs.getString("id");
			System.out.println("Name " + i);
			data = rs.getString("data");
			i++;		
		}
		con.close();
		
		
	}
	
	
	private int insertUtfData(String key, String data,String latin,String desc) throws Exception {
		
		PreparedStatement pstm;
		int resu=-1;		
		pstm = con.prepareStatement("insert into utfdata (id,data,latin,description) values (?,?,?,?)");
		pstm.setString(1,key);

		//		StringReader sr = new StringReader(data);
		//StringReader sr=new StringReader(xmldata);
		//int len=xmldata.length();
		//int len = data.length();
		//pstm.setCharacterStream (2, sr, len );

			       pstm.setString(2,xmldata);
		pstm.setString(3,latin);
		pstm.setString(4,desc);
		resu = pstm.executeUpdate();
		pstm.close();
		return resu;
		
	}

    private static String readXML() throws Exception{
	String result="";
	//URL u=new URL("http://jeannicod.ccsd.cnrs.fr/perl/oai?verb=GetRecord&identifier=oai%3ACCSDJeanNicod%3Aijn_00000044&metadataPrefix=oai_dc");
	URL u=new URL("http://arc.cs.odu.edu:8080/oai/servlet/OAI-DP?verb=Identify");
        HttpURLConnection conn=null;
	
        conn=(HttpURLConnection)u.openConnection();
	System.out.println("getContentEncoding()"+conn.getContentEncoding()+conn.getContentType());
	BufferedReader breader = new BufferedReader (new InputStreamReader(conn.getInputStream(),"UTF-8"));
	String inputLine=null;

        while ((inputLine = breader.readLine()) != null){ 
	    //  System.out.println(inputLine);
	    result=result+inputLine;
	}
        breader.close();
	return result;
        
    }
	
}
	
